# Change history for coverage.py

These changes are listed in decreasing version number order. Note this can be different from a strict chronological order when there are two branches in development at the same time, such as 4.5.x and 5.0.

See Migrating between versions for significant changes that might be required when upgrading your version of coverage.py.

## Version 7.4.4 — 2024-03-14

- Fix: in some cases, even with `[run] relative_files=True`, a data file could be created with absolute path names. When combined with other relative data files, it was random whether the absolute file names would be made relative or not. If they weren’t, then a file would be listed twice in reports, as detailed in issue 1752. This is now fixed: absolute file names are always made relative when combining. Thanks to Bruno Rodrigues dos Santos for support.

- Fix: the last case of a match/case statement had an incorrect message if the branch was missed. It said the pattern never matched, when actually the branch is missed if the last case always matched.

- Fix: clicking a line number in the HTML report now positions more accurately.

- Fix: the `report:format` setting was defined as a boolean, but should be a string. Thanks, Tanaydin Sirin. It is also now documented on the configuration page.

## Version 7.4.3 — 2024-02-23

- Fix: in some cases, coverage could fail with a RuntimeError: “Set changed size during iteration.” This is now fixed, closing issue 1733.

## Version 7.4.2 — 2024-02-20

- Fix: setting `COVERAGE_CORE=sysmon` no longer errors on 3.11 and lower, thanks Hugo van Kemenade. It now issues a warning that sys.monitoring is not available and falls back to the default core instead.

## Version 7.4.1 — 2024-01-26

- Python 3.13.0a3 is supported.

- Fix: the JSON report now includes an explicit format version number, closing issue 1732.

## Version 7.4.0 — 2023-12-27

- In Python 3.12 and above, you can try an experimental core based on the new `sys.monitoring` module by defining a `COVERAGE_CORE=sysmon` environment variable. This should be faster for line coverage, but not for branch coverage, and plugins and dynamic contexts are not yet supported with it. I am very interested to hear how it works (or doesn’t!) for you.

## Version 7.3.4 — 2023-12-20

- Fix: the change for multi-line signature exclusions in 7.3.3 broke other forms of nested clauses being excluded properly. This is now fixed, closing issue 1713.

- Fix: in the HTML report, selecting code for copying won’t select the line numbers also. Thanks, Robert Harris.

## Version 7.3.3 — 2023-12-14

- Fix: function definitions with multi-line signatures can now be excluded by matching any of the lines, closing issue 684. Thanks, Jan Rusak, Maciej Kowalczyk and Joanna Ejzel.

- Fix: XML reports could fail with a TypeError if files had numeric components that were duplicates except for leading zeroes, like `file1.py` and `file001.py`. Fixes issue 1709.

- The `coverage annotate` command used to announce that it would be removed in a future version. Enough people got in touch to say that they use it, so it will stay. Don’t expect it to keep up with other new features though.

- Added new debug options:

  - `pytest` writes the pytest test name into the debug output.

  - `dataop2` writes the full data being added to CoverageData objects.

## Version 7.3.2 — 2023-10-02

- The `coverage lcov` command ignored the `[report] exclude_lines` and `[report] exclude_also` settings (issue 1684). This is now fixed, thanks Jacqueline Lee.

- Sometimes SQLite will create journal files alongside the coverage.py database files. These are ephemeral, but could be mistakenly included when combining data files. Now they are always ignored, fixing issue 1605. Thanks to Brad Smith for suggesting fixes and providing detailed debugging.

- On Python 3.12+, we now disable SQLite writing journal files, which should be a little faster.

- The new 3.12 soft keyword `type` is properly bolded in HTML reports.

- Removed the “fullcoverage” feature used by CPython to measure the coverage of early-imported standard library modules. CPython stopped using it in 2021, and it stopped working completely in Python 3.13.

## Version 7.3.1 — 2023-09-06

- The semantics of stars in file patterns has been clarified in the docs. A leading or trailing star matches any number of path components, like a double star would. This is different than the behavior of a star in the middle of a pattern. This discrepancy was identified by Sviatoslav Sydorenko, who provided patient detailed diagnosis and graciously agreed to a pragmatic resolution.

- The API docs were missing from the last version. They are now restored.

## Version 7.3.0 — 2023-08-12

- Added a `Coverage.collect()` context manager to start and stop coverage data collection.

- Dropped support for Python 3.7.

- Fix: in unusual circumstances, SQLite cannot be set to asynchronous mode. Coverage.py would fail with the error `Safety level may not be changed inside a transaction.` This is now avoided, closing issue 1646. Thanks to Michael Bell for the detailed bug report.

- Docs: examples of configuration files now include separate examples for the different syntaxes: .coveragerc, pyproject.toml, setup.cfg, and tox.ini.

- Fix: added `nosemgrep` comments to our JavaScript code so that semgrep-based SAST security checks won’t raise false alarms about security problems that aren’t problems.

- Added a CITATION.cff file, thanks to Ken Schackart.

## Version 7.2.7 — 2023-05-29

- Fix: reverted a change from 6.4.3 that helped Cython, but also increased the size of data files when using dynamic contexts, as described in the now-fixed issue 1586. The problem is now avoided due to a recent change (issue 1538). Thanks to Anders Kaseorg and David Szotten for persisting with problem reports and detailed diagnoses.

- Wheels are now provided for CPython 3.12.

## Version 7.2.6 — 2023-05-23

- Fix: the `lcov` command could raise an IndexError exception if a file is translated to Python but then executed under its own name. Jinja2 does this when rendering templates. Fixes issue 1553.

- Python 3.12 beta 1 now inlines comprehensions. Previously they were compiled as invisible functions and coverage.py would warn you if they weren’t completely executed. This no longer happens under Python 3.12.

- Fix: the `coverage debug sys` command includes some environment variables in its output. This could have included sensitive data. Those values are now hidden with asterisks, closing issue 1628.

## Version 7.2.5 — 2023-04-30

- Fix: `html_report()` could fail with an AttributeError on `isatty` if run in an unusual environment where sys.stdout had been replaced. This is now fixed.

## Version 7.2.4 — 2023-04-28

PyCon 2023 sprint fixes!

- Fix: with `relative_files = true`, specifying a specific file to include or omit wouldn’t work correctly (issue 1604). This is now fixed, with testing help by Marc Gibbons.

- Fix: the XML report would have an incorrect `<source>` element when using relative files and the source option ended with a slash (issue 1541). This is now fixed, thanks to Kevin Brown-Silva.

- When the HTML report location is printed to the terminal, it’s now a terminal-compatible URL, so that you can click the location to open the HTML file in your browser. Finishes issue 1523 thanks to Ricardo Newbery.

- Docs: a new Migrating page with details about how to migrate between major versions of coverage.py. It currently covers the wildcard changes in 7.x. Thanks, Brian Grohe.

## Version 7.2.3 — 2023-04-06

- Fix: the [run] sigterm setting was meant to capture data if a process was terminated with a SIGTERM signal, but it didn’t always. This was fixed thanks to Lewis Gaul, closing issue 1599.

- Performance: HTML reports with context information are now much more compact. File sizes are typically as small as one-third the previous size, but can be dramatically smaller. This closes issue 1584 thanks to Oleh Krehel.

- Development dependencies no longer use hashed pins, closing issue 1592.

## Version 7.2.2 — 2023-03-16

- Fix: if a virtualenv was created inside a source directory, and a sourced package was installed inside the virtualenv, then all of the third-party packages inside the virtualenv would be measured. This was incorrect, but has now been fixed: only the specified packages will be measured, thanks to Manuel Jacob.

- Fix: the `coverage lcov` command could create a .lcov file with incorrect LF (lines found) and LH (lines hit) totals. This is now fixed, thanks to Ian Moore.

- Fix: the `coverage xml` command on Windows could create a .xml file with duplicate `<package>` elements. This is now fixed, thanks to Benjamin Parzella, closing issue 1573.

## Version 7.2.1 — 2023-02-26

- Fix: the PyPI page had broken links to documentation pages, but no longer does, closing issue 1566.

- Fix: public members of the coverage module are now properly indicated so that mypy will find them, fixing issue 1564.

## Version 7.2.0 — 2023-02-22

- Added a new setting `[report] exclude_also` to let you add more exclusions without overwriting the defaults. Thanks, Alpha Chen, closing issue 1391.

- Added a `CoverageData.purge_files()` method to remove recorded data for a particular file. Contributed by Stephan Deibel.

- Fix: when reporting commands fail, they will no longer congratulate themselves with messages like “Wrote XML report to file.xml” before spewing a traceback about their failure.

- Fix: arguments in the public API that name file paths now accept pathlib.Path objects. This includes the `data_file` and `config_file` arguments to the Coverage constructor and the `basename` argument to CoverageData. Closes issue 1552.

- Fix: In some embedded environments, an IndexError could occur on stop() when the originating thread exits before completion. This is now fixed, thanks to Russell Keith-Magee, closing issue 1542.

- Added a `py.typed` file to announce our type-hintedness. Thanks, KotlinIsland.

## Version 7.1.0 — 2023-01-24

- Added: the debug output file can now be specified with `[run] debug_file` in the configuration file. Closes issue 1319.

- Performance: fixed a slowdown with dynamic contexts that’s been around since 6.4.3. The fix closes issue 1538. Thankfully this doesn’t break the Cython change that fixed issue 972. Thanks to Mathieu Kniewallner for the deep investigative work and comprehensive issue report.

- Typing: all product and test code has type annotations.

## Version 7.0.5 — 2023-01-10

- Fix: On Python 3.7, a file with type annotations but no `from __future__ import annotations` would be missing statements in the coverage report. This is now fixed, closing issue 1524.

## Version 7.0.4 — 2023-01-07

- Performance: an internal cache of file names was accidentally disabled, resulting in sometimes drastic reductions in performance. This is now fixed, closing issue 1527. Thanks to Ivan Ciuvalschii for the reproducible test case.

## Version 7.0.3 — 2023-01-03

- Fix: when using pytest-cov or pytest-xdist, or perhaps both, the combining step could fail with `assert row is not None` using 7.0.2. This was due to a race condition that has always been possible and is still possible. In 7.0.1 and before, the error was silently swallowed by the combining code. Now it will produce a message “Couldn’t combine data file” and ignore the data file as it used to do before 7.0.2. Closes issue 1522.

## Version 7.0.2 — 2023-01-02

- Fix: when using the `[run] relative_files = True` setting, a relative `[paths]` pattern was still being made absolute. This is now fixed, closing issue 1519.

- Fix: if Python doesn’t provide tomllib, then TOML configuration files can only be read if coverage.py is installed with the `[toml]` extra. Coverage.py will raise an error if TOML support is not installed when it sees your settings are in a .toml file. But it didn’t understand that `[tools.coverage]` was a valid section header, so the error wasn’t reported if you used that header, and settings were silently ignored. This is now fixed, closing issue 1516.

- Fix: adjusted how decorators are traced on PyPy 7.3.10, fixing issue 1515.

- Fix: the `coverage lcov` report did not properly implement the `--fail-under=MIN` option. This has been fixed.

- Refactor: added many type annotations, including a number of refactorings. This should not affect outward behavior, but they were a bit invasive in some places, so keep your eyes peeled for oddities.

- Refactor: removed the vestigial and long untested support for Jython and IronPython.

## Version 7.0.1 — 2022-12-23

- When checking if a file mapping resolved to a file that exists, we weren’t considering files in .whl files. This is now fixed, closing issue 1511.

- File pattern rules were too strict, forbidding plus signs and curly braces in directory and file names. This is now fixed, closing issue 1513.

- Unusual Unicode or control characters in source files could prevent reporting. This is now fixed, closing issue 1512.

- The PyPy wheel now installs on PyPy 3.7, 3.8, and 3.9, closing issue 1510.

## Version 7.0.0 — 2022-12-18

Nothing new beyond 7.0.0b1.

## Version 7.0.0b1 — 2022-12-03

A number of changes have been made to file path handling, including pattern matching and path remapping with the `[paths]` setting (see [paths]). These changes might affect you, and require you to update your settings.

(This release includes the changes from 6.6.0b1, since 6.6.0 was never released.)

- Changes to file pattern matching, which might require updating your configuration:

  - Previously, `*` would incorrectly match directory separators, making precise matching difficult. This is now fixed, closing issue 1407.

  - Now `**` matches any number of nested directories, including none.

- Improvements to combining data files when using the [run] relative_files setting, which might require updating your configuration:

  - During `coverage combine`, relative file paths are implicitly combined without needing a `[paths]` configuration setting. This also fixed issue 991.

  - A `[paths]` setting like `*/foo` will now match `foo/bar.py` so that relative file paths can be combined more easily.

  - The [run] relative_files setting is properly interpreted in more places, fixing issue 1280.

- When remapping file paths with `[paths]`, a path will be remapped only if the resulting path exists. The documentation has long said the prefix had to exist, but it was never enforced. This fixes issue 608, improves issue 649, and closes issue 757.

- Reporting operations now implicitly use the `[paths]` setting to remap file paths within a single data file. Combining multiple files still requires the `coverage combine` step, but this simplifies some single-file situations. Closes issue 1212 and issue 713.

- The `coverage report` command now has a `--format=` option. The original style is now `--format=text`, and is the default.

  - Using `--format=markdown` will write the table in Markdown format, thanks to Steve Oswald, closing issue 1418.

  - Using `--format=total` will write a single total number to the output. This can be useful for making badges or writing status updates.

- Combining data files with `coverage combine` now hashes the data files to skip files that add no new information. This can reduce the time needed. Many details affect the speed-up, but for coverage.py’s own test suite, combining is about 40% faster. Closes issue 1483.

- When searching for completely un-executed files, coverage.py uses the presence of `__init__.py` files to determine which directories have source that could have been imported. However, implicit namespace packages don’t require `__init__.py`. A new setting `[report] include_namespace_packages` tells coverage.py to consider these directories during reporting. Thanks to Felix Horvat for the contribution. Closes issue 1383 and issue 1024.

- Fixed environment variable expansion in pyproject.toml files. It was overly broad, causing errors outside of coverage.py settings, as described in issue 1481 and issue 1345. This is now fixed, but in rare cases will require changing your pyproject.toml to quote non-string values that use environment substitution.

- An empty file has a coverage total of 100%, but used to fail with `--fail-under`. This has been fixed, closing issue 1470.

- The text report table no longer writes out two separator lines if there are no files listed in the table. One is plenty.

- Fixed a mis-measurement of a strange use of wildcard alternatives in match/case statements, closing issue 1421.

- Fixed internal logic that prevented coverage.py from running on implementations other than CPython or PyPy (issue 1474).

- The deprecated `[run] note` setting has been completely removed.

## Version 6.6.0b1 — 2022-10-31

(Note: 6.6.0 final was never released. These changes are part of 7.0.0b1.)

- Changes to file pattern matching, which might require updating your configuration:

  - Previously, `*` would incorrectly match directory separators, making precise matching difficult. This is now fixed, closing issue 1407.

  - Now `**` matches any number of nested directories, including none.

- Improvements to combining data files when using the [run] relative_files setting:

  - During `coverage combine`, relative file paths are implicitly combined without needing a `[paths]` configuration setting. This also fixed issue 991.

  - A `[paths]` setting like `*/foo` will now match `foo/bar.py` so that relative file paths can be combined more easily.

  - The setting is properly interpreted in more places, fixing issue 1280.

- Fixed environment variable expansion in pyproject.toml files. It was overly broad, causing errors outside of coverage.py settings, as described in issue 1481 and issue 1345. This is now fixed, but in rare cases will require changing your pyproject.toml to quote non-string values that use environment substitution.

- Fixed internal logic that prevented coverage.py from running on implementations other than CPython or PyPy (issue 1474).

## Version 6.5.0 — 2022-09-29

- The JSON report now includes details of which branches were taken, and which are missing for each file. Thanks, Christoph Blessing. Closes issue 1425.

- Starting with coverage.py 6.2, `class` statements were marked as a branch. This wasn’t right, and has been reverted, fixing issue 1449. Note this will very slightly reduce your coverage total if you are measuring branch coverage.

- Packaging is now compliant with PEP 517, closing issue 1395.

- A new debug option `--debug=pathmap` shows details of the remapping of paths that happens during combine due to the `[paths]` setting.

- Fix an internal problem with caching of invalid Python parsing. Found by OSS-Fuzz, fixing their bug 50381.

## Version 6.4.4 — 2022-08-16

- Wheels are now provided for Python 3.11.

## Version 6.4.3 — 2022-08-06

- Fix a failure when combining data files if the file names contained glob-like patterns. Thanks, Michael Krebs and Benjamin Schubert.

- Fix a messaging failure when combining Windows data files on a different drive than the current directory, closing issue 1428. Thanks, Lorenzo Micò.

- Fix path calculations when running in the root directory, as you might do in a Docker container. Thanks Arthur Rio.

- Filtering in the HTML report wouldn’t work when reloading the index page. This is now fixed. Thanks, Marc Legendre.

- Fix a problem with Cython code measurement, closing issue 972. Thanks, Matus Valo.

## Version 6.4.2 — 2022-07-12

- Updated for a small change in Python 3.11.0 beta 4: modules now start with a line with line number 0, which is ignored. This line cannot be executed, so coverage totals were thrown off. This line is now ignored by coverage.py, but this also means that truly empty modules (like `__init__.py`) have no lines in them, rather than one phantom line. Fixes issue 1419.

- Internal debugging data added to sys.modules is now an actual module, to avoid confusing code that examines everything in sys.modules. Thanks, Yilei Yang.

## Version 6.4.1 — 2022-06-02

- Greatly improved performance on PyPy, and other environments that need the pure Python trace function. Thanks, Carl Friedrich Bolz-Tereick (pull 1381 and pull 1388). Slightly improved performance when using the C trace function, as most environments do. Closes issue 1339.

- The conditions for using tomllib from the standard library have been made more precise, so that 3.11 alphas will continue to work. Closes issue 1390.

## Version 6.4 — 2022-05-22

- A new setting, [run] sigterm, controls whether a SIGTERM signal handler is used. In 6.3, the signal handler was always installed, to capture data at unusual process ends. Unfortunately, this introduced other problems (see issue 1310). Now the signal handler is only used if you opt-in by setting `[run] sigterm = true`.

- Small changes to the HTML report:

  - Added links to next and previous file, and more keyboard shortcuts: `[` and `]` for next file and previous file; `u` for up to the index; and `?` to open/close the help panel. Thanks, J. M. F. Tsang.

  - The time stamp and version are displayed at the top of the report. Thanks, Ammar Askar. Closes issue 1351.

- A new debug option `debug=sqldata` adds more detail to `debug=sql`, logging all the data being written to the database.

- Previously, running `coverage report` (or any of the reporting commands) in an empty directory would create a .coverage data file. Now they do not, fixing issue 1328.

- On Python 3.11, the `[toml]` extra no longer installs tomli, instead using tomllib from the standard library. Thanks Shantanu.

- In-memory CoverageData objects now properly update(), closing issue 1323.

## Version 6.3.3 — 2022-05-12

- Fix: Coverage.py now builds successfully on CPython 3.11 (3.11.0b1) again. Closes issue 1367. Some results for generators may have changed.

## Version 6.3.2 — 2022-02-20

- Fix: adapt to pypy3.9’s decorator tracing behavior. It now traces function decorators like CPython 3.8: both the @-line and the def-line are traced. Fixes issue 1326.

- Debug: added `pybehave` to the list of coverage debug and --debug options.

- Fix: show an intelligible error message if `--concurrency=multiprocessing` is used without a configuration file. Closes issue 1320.

## Version 6.3.1 — 2022-02-01

- Fix: deadlocks could occur when terminating processes. Some of these deadlocks (described in issue 1310) are now fixed.

- Fix: a signal handler was being set from multiple threads, causing an error: “ValueError: signal only works in main thread”. This is now fixed, closing issue 1312.

- Fix: `--precision` on the command-line was being ignored while considering `--fail-under`. This is now fixed, thanks to Marcelo Trylesinski.

- Fix: releases no longer provide 3.11.0-alpha wheels. Coverage.py uses CPython internal fields which are moving during the alpha phase. Fixes issue 1316.

## Version 6.3 — 2022-01-25

- Feature: Added the `lcov` command to generate reports in LCOV format. Thanks, Bradley Burns. Closes issues 587 and 626.

- Feature: the coverage data file can now be specified on the command line with the `--data-file` option in any command that reads or writes data. This is in addition to the existing `COVERAGE_FILE` environment variable. Closes issue 624. Thanks, Nikita Bloshchanevich.

- Feature: coverage measurement data will now be written when a SIGTERM signal is received by the process. This includes `Process.terminate`, and other ways to terminate a process. Currently this is only on Linux and Mac; Windows is not supported. Fixes issue 1307.

- Dropped support for Python 3.6, which reached end-of-life on 2021-12-23.

- Updated Python 3.11 support to 3.11.0a4, fixing issue 1294.

- Fix: the coverage data file is now created in a more robust way, to avoid problems when multiple processes are trying to write data at once. Fixes issues 1303 and 883.

- Fix: a .gitignore file will only be written into the HTML report output directory if the directory is empty. This should prevent certain unfortunate accidents of writing the file where it is not wanted.

- Releases now have MacOS arm64 wheels for Apple Silicon, fixing issue 1288.

## Version 6.2 — 2021-11-26

- Feature: Now the `--concurrency` setting can have a list of values, so that threads and another lightweight threading package can be measured together, such as `--concurrency=gevent,thread`. Closes issue 1012 and issue 1082. This also means that `thread` must be explicitly specified in some cases that used to be implicit such as `--concurrency=multiprocessing`, which must be changed to `--concurrency=multiprocessing,thread`.

- Fix: A module specified as the `source` setting is imported during startup, before the user program imports it. This could cause problems if the rest of the program isn’t ready yet. For example, issue 1203 describes a Django setting that is accessed before settings have been configured. Now the early import is wrapped in a try/except so errors then don’t stop execution.

- Fix: A colon in a decorator expression would cause an exclusion to end too early, preventing the exclusion of the decorated function. This is now fixed.

- Fix: The HTML report now will not overwrite a .gitignore file that already exists in the HTML output directory (follow-on for issue 1244).

- API: The exceptions raised by Coverage.py have been specialized, to provide finer-grained catching of exceptions by third-party code.

- API: Using `suffix=False` when constructing a Coverage object with multiprocessing wouldn’t suppress the data file suffix (issue 989). This is now fixed.

- Debug: The `coverage debug data` command will now sniff out combinable data files, and report on all of them.

- Debug: The `coverage debug` command used to accept a number of topics at a time, and show all of them, though this was never documented. This no longer works, to allow for command-line options in the future.

## Version 6.1.2 — 2021-11-10

- Python 3.11 is supported (tested with 3.11.0a2). One still-open issue has to do with exits through with-statements.

- Fix: When remapping file paths through the `[paths]` setting while combining, the `[run] relative_files` setting was ignored, resulting in absolute paths for remapped file names (issue 1147). This is now fixed.

- Fix: Complex conditionals over excluded lines could have incorrectly reported a missing branch (issue 1271). This is now fixed.

- Fix: More exceptions are now handled when trying to parse source files for reporting. Problems that used to terminate coverage.py can now be handled with `[report] ignore_errors`. This helps with plugins failing to read files (django_coverage_plugin issue 78).

- Fix: Removed another vestige of jQuery from the source tarball (issue 840).

- Fix: Added a default value for a new-to-6.x argument of an internal class. This unsupported class is being used by coveralls (issue 1273). Although I’d rather not “fix” unsupported interfaces, it’s actually nicer with a default value.

## Version 6.1.1 — 2021-10-31

- Fix: The sticky header on the HTML report didn’t work unless you had branch coverage enabled. This is now fixed: the sticky header works for everyone. (Do people still use coverage without branch measurement!? j/k)

- Fix: When using explicitly declared namespace packages, the “already imported a file that will be measured” warning would be issued (issue 888). This is now fixed.

## Version 6.1 — 2021-10-30

- Deprecated: The `annotate` command and the `Coverage.annotate` function will be removed in a future version, unless people let me know that they are using it. Instead, the `html` command gives better-looking (and more accurate) output, and the `report -m` command will tell you line numbers of missing lines. Please get in touch if you have a reason to use `annotate` over those better options: ned@nedbatchelder.com.

- Feature: Coverage now sets an environment variable, `COVERAGE_RUN` when running your code with the `coverage run` command. The value is not important, and may change in the future. Closes issue 553.

- Feature: The HTML report pages for Python source files now have a sticky header so the file name and controls are always visible.

- Feature: The `xml` and `json` commands now describe what they wrote where.

- Feature: The `html`, `combine`, `xml`, and `json` commands all accept a `-q/--quiet` option to suppress the messages they write to stdout about what they are doing (issue 1254).

- Feature: The `html` command writes a `.gitignore` file into the HTML output directory, to prevent the report from being committed to git. If you want to commit it, you will need to delete that file. Closes issue 1244.

- Feature: Added support for PyPy 3.8.

- Fix: More generated code is now excluded from measurement. Code such as attrs boilerplate, or doctest code, was being measured though the synthetic line numbers meant they were never reported. Once Cython was involved though, the generated .so files were parsed as Python, raising syntax errors, as reported in issue 1160. This is now fixed.

- Fix: When sorting human-readable names, numeric components are sorted correctly: file10.py will appear after file9.py. This applies to file names, module names, environment variables, and test contexts.

- Performance: Branch coverage measurement is faster, though you might only notice on code that is executed many times, such as long-running loops.

- Build: jQuery is no longer used or vendored (issue 840 and issue 1118). Huge thanks to Nils Kattenbeck (septatrix) for the conversion to vanilla JavaScript in pull request 1248.

## Version 6.0.2 — 2021-10-11

- Namespace packages being measured weren’t properly handled by the new code that ignores third-party packages. If the namespace package was installed, it was ignored as a third-party package. That problem (issue 1231) is now fixed.

- Packages named as “source packages” (with `source`, or `source_pkgs`, or pytest-cov’s `--cov`) might have been only partially measured. Their top-level statements could be marked as un-executed, because they were imported by coverage.py before measurement began (issue 1232). This is now fixed, but the package will be imported twice, once by coverage.py, then again by your test suite. This could cause problems if importing the package has side effects.

- The `CoverageData.contexts_by_lineno()` method was documented to return a dict, but was returning a defaultdict. Now it returns a plain dict. It also no longer returns negative numbered keys.

## Version 6.0.1 — 2021-10-06

- In 6.0, the coverage.py exceptions moved from coverage.misc to coverage.exceptions. These exceptions are not part of the public supported API, CoverageException is. But a number of other third-party packages were importing the exceptions from coverage.misc, so they are now available from there again (issue 1226).

- Changed an internal detail of how tomli is imported, so that tomli can use coverage.py for their own test suite (issue 1228).

- Defend against an obscure possibility under code obfuscation, where a function can have an argument called “self”, but no local named “self” (pull request 1210). Thanks, Ben Carlsson.

## Version 6.0 — 2021-10-03

- The `coverage html` command now prints a message indicating where the HTML report was written. Fixes issue 1195.

- The `coverage combine` command now prints messages indicating each data file being combined. Fixes issue 1105.

- The HTML report now includes a sentence about skipped files due to `skip_covered` or `skip_empty` settings. Fixes issue 1163.

- Unrecognized options in the configuration file are no longer errors. They are now warnings, to ease the use of coverage across versions. Fixes issue 1035.

- Fix handling of exceptions through context managers in Python 3.10. A missing exception is no longer considered a missing branch from the with statement. Fixes issue 1205.

- Fix another rarer instance of “Error binding parameter 0 - probably unsupported type.” (issue 1010).

- Creating a directory for the coverage data file now is safer against conflicts when two coverage runs happen simultaneously (pull 1220). Thanks, Clément Pit-Claudel.

## Version 6.0b1 — 2021-07-18

- Dropped support for Python 2.7, PyPy 2, and Python 3.5.

- Added support for the Python 3.10 `match/case` syntax.

- Data collection is now thread-safe. There may have been rare instances of exceptions raised in multi-threaded programs.

- Plugins (like the Django coverage plugin) were generating “Already imported a file that will be measured” warnings about Django itself. These have been fixed, closing issue 1150.

- Warnings generated by coverage.py are now real Python warnings.

- Using `--fail-under=100` with coverage near 100% could result in the self-contradictory message `total of 100 is less than fail-under=100`. This bug (issue 1168) is now fixed.

- The `COVERAGE_DEBUG_FILE` environment variable now accepts `stdout` and `stderr` to write to those destinations.

- TOML parsing now uses the tomli library.

- Some minor changes to usually invisible details of the HTML report:

  - Use a modern hash algorithm when fingerprinting, for high-security environments (issue 1189). When generating the HTML report, we save the hash of the data, to avoid regenerating an unchanged HTML page. We used to use MD5 to generate the hash, and now use SHA-3-256. This was never a security concern, but security scanners would notice the MD5 algorithm and raise a false alarm.

  - Change how report file names are generated, to avoid leading underscores (issue 1167), to avoid rare file name collisions (issue 584), and to avoid file names becoming too long (issue 580).

## Version 5.6b1 — 2021-04-13

Note: 5.6 final was never released. These changes are part of 6.0.

- Third-party packages are now ignored in coverage reporting. This solves a few problems:

  - Coverage will no longer report about other people’s code (issue 876). This is true even when using `--source=.` with a venv in the current directory.

  - Coverage will no longer generate “Already imported a file that will be measured” warnings about coverage itself (issue 905).

- The HTML report uses j/k to move up and down among the highlighted chunks of code. They used to highlight the current chunk, but 5.0 broke that behavior. Now the highlighting is working again.

- The JSON report now includes `percent_covered_display`, a string with the total percentage, rounded to the same number of decimal places as the other reports’ totals.

## Version 5.5 — 2021-02-28

- `coverage combine` has a new option, `--keep` to keep the original data files after combining them. The default is still to delete the files after they have been combined. This was requested in issue 1108 and implemented in pull request 1110. Thanks, Éric Larivière.

- When reporting missing branches in `coverage report`, branches aren’t reported that jump to missing lines. This adds to the long-standing behavior of not reporting branches from missing lines. Now branches are only reported if both the source and destination lines are executed. Closes both issue 1065 and issue 955.

- Minor improvements to the HTML report:

  - The state of the line visibility selector buttons is saved in local storage so you don’t have to fiddle with them so often, fixing issue 1123.

  - It has a little more room for line numbers so that 4-digit numbers work well, fixing issue 1124.

- Improved the error message when combining line and branch data, so that users will be more likely to understand what’s happening, closing issue 803.

## Version 5.4 — 2021-01-24

- The text report produced by `coverage report` now always outputs a TOTAL line, even if only one Python file is reported. This makes regex parsing of the output easier. Thanks, Judson Neer. This had been requested a number of times (issue 1086, issue 922, issue 732).

- The `skip_covered` and `skip_empty` settings in the configuration file can now be specified in the `[html]` section, so that text reports and HTML reports can use separate settings. The HTML report will still use the `[report]` settings if there isn’t a value in the `[html]` section. Closes issue 1090.

- Combining files on Windows across drives now works properly, fixing issue 577. Thanks, Valentin Lab.

- Fix an obscure warning from deep in the _decimal module, as reported in issue 1084.

- Update to support Python 3.10 alphas in progress, including PEP 626: Precise line numbers for debugging and other tools.

## Version 5.3.1 — 2020-12-19

- When using `--source` on a large source tree, v5.x was slower than previous versions. This performance regression is now fixed, closing issue 1037.

- Mysterious SQLite errors can happen on PyPy, as reported in issue 1010. An immediate retry seems to fix the problem, although it is an unsatisfying solution.

- The HTML report now saves the sort order in a more widely supported way, fixing issue 986. Thanks, Sebastián Ramírez (pull request 1066).

- The HTML report pages now have a Sleepy Snake favicon.

- Wheels are now provided for manylinux2010, and for PyPy3 (pp36 and pp37).

- Continuous integration has moved from Travis and AppVeyor to GitHub Actions.

## Version 5.3 — 2020-09-13

- The `source` setting has always been interpreted as either a file path or a module, depending on which existed. If both interpretations were valid, it was assumed to be a file path. The new `source_pkgs` setting can be used to name a package to disambiguate this case. Thanks, Thomas Grainger. Fixes issue 268.

- If a plugin was disabled due to an exception, we used to still try to record its information, causing an exception, as reported in issue 1011. This is now fixed.

## Version 5.2.1 — 2020-07-23

- The dark mode HTML report still used light colors for the context listing, making them unreadable (issue 1009). This is now fixed.

- The time stamp on the HTML report now includes the time zone. Thanks, Xie Yanbo (pull request 960).

## Version 5.2 — 2020-07-05

- The HTML report has been redesigned by Vince Salvino. There is now a dark mode, the code text is larger, and system sans serif fonts are used, in addition to other small changes (issue 858 and pull request 931).

- The `coverage report` and `coverage html` commands now accept a `--precision` option to control the number of decimal points displayed. Thanks, Teake Nutma (pull request 982).

- The `coverage report` and `coverage html` commands now accept a `--no-skip-covered` option to negate `--skip-covered`. Thanks, Anthony Sottile (issue 779 and pull request 932).

- The `--skip-empty` option is now available for the XML report, closing issue 976.

- The `coverage report` command now accepts a `--sort` option to specify how to sort the results. Thanks, Jerin Peter George (pull request 1005).

- If coverage fails due to the coverage total not reaching the `--fail-under` value, it will now print a message making the condition clear. Thanks, Naveen Yadav (pull request 977).

- TOML configuration files with non-ASCII characters would cause errors on Windows (issue 990). This is now fixed.

- The output of `--debug=trace` now includes information about how the `--source` option is being interpreted, and the module names being considered.

## Version 5.1 — 2020-04-12

- The JSON report now includes counts of covered and missing branches. Thanks, Salvatore Zagaria.

- On Python 3.8, try-finally-return reported wrong branch coverage with decorated async functions (issue 964). This is now fixed. Thanks, Kjell Braden.

- The `get_option()` and `set_option()` methods can now manipulate the `[paths]` configuration setting. Thanks to Bernát Gábor for the fix for issue 967.

## Version 5.0.4 — 2020-03-16

- If using the `[run] relative_files` setting, the XML report will use relative files in the `<source>` elements indicating the location of source code. Closes issue 948.

- The textual summary report could report missing lines with negative line numbers on PyPy3 7.1 (issue 943). This is now fixed.

- Windows wheels for Python 3.8 were incorrectly built, but are now fixed. (issue 949)

- Updated Python 3.9 support to 3.9a4.

- HTML reports couldn’t be sorted if localStorage wasn’t available. This is now fixed: sorting works even though the sorting setting isn’t retained. (issue 944 and pull request 945). Thanks, Abdeali Kothari.

## Version 5.0.3 — 2020-01-12

- A performance improvement in 5.0.2 didn’t work for test suites that changed directory before combining data, causing “Couldn’t use data file: no such table: meta” errors (issue 916). This is now fixed.

- Coverage could fail to run your program with some form of “ModuleNotFound” or “ImportError” trying to import from the current directory. This would happen if coverage had been packaged into a zip file (for example, on Windows), or was found indirectly (for example, by pyenv-virtualenv). A number of different scenarios were described in issue 862 which is now fixed. Huge thanks to Agbonze O. Jeremiah for reporting it, and Alexander Waters and George-Cristian Bîrzan for protracted debugging sessions.

- Added the “premain” debug option.

- Added SQLite compile-time options to the “debug sys” output.

## Version 5.0.2 — 2020-01-05

- Programs that used multiprocessing and changed directories would fail under coverage. This is now fixed (issue 890). A side effect is that debug information about the config files read now shows absolute paths to the files.

- When running programs as modules (`coverage run -m`) with `--source`, some measured modules were imported before coverage starts. This resulted in unwanted warnings (“Already imported a file that will be measured”) and a reduction in coverage totals (issue 909). This is now fixed.

- If no data was collected, an exception about “No data to report” could happen instead of a 0% report being created (issue 884). This is now fixed.

- The handling of source files with non-encodable file names has changed. Previously, if a file name could not be encoded as UTF-8, an error occurred, as described in issue 891. Now, those files will not be measured, since their data would not be recordable.

- A new warning (“dynamic-conflict”) is issued if two mechanisms are trying to change the dynamic context. Closes issue 901.

- `coverage run --debug=sys` would fail with an AttributeError. This is now fixed (issue 907).

## Version 5.0.1 — 2019-12-22

- If a 4.x data file is the cause of a “file is not a database” error, then use a more specific error message, “Looks like a coverage 4.x data file, are you mixing versions of coverage?” Helps diagnose the problems described in issue 886.

- Measurement contexts and relative file names didn’t work together, as reported in issue 899 and issue 900. This is now fixed, thanks to David Szotten.

- When using `coverage run --concurrency=multiprocessing`, all data files should be named with parallel-ready suffixes. 5.0 mistakenly named the main process’ file with no suffix when using `--append`. This is now fixed, closing issue 880.

- Fixed a problem on Windows when the current directory is changed to a different drive (issue 895). Thanks, Olivier Grisel.

- Updated Python 3.9 support to 3.9a2.

## Version 5.0 — 2019-12-14

Nothing new beyond 5.0b2.

A summary of major changes in 5.0 since 4.5.x is in see Major changes in 5.0.

## Version 5.0b2 — 2019-12-08

- An experimental `[run] relative_files` setting tells coverage to store relative file names in the data file. This makes it easier to run tests in one (or many) environments, and then report in another. It has not had much real-world testing, so it may change in incompatible ways in the future.

- When constructing a `coverage.Coverage` object, data_file can be specified as None to prevent writing any data file at all. In previous versions, an explicit data_file=None argument would use the default of “.coverage”. Fixes issue 871.

- Python files run with `-m` now have `__spec__` defined properly. This fixes issue 745 (about not being able to run unittest tests that spawn subprocesses), and issue 838, which described the problem directly.

- The `[paths]` configuration section is now ordered. If you specify more than one list of patterns, the first one that matches will be used. Fixes issue 649.

- The `coverage.numbits.register_sqlite_functions()` function now also registers numbits_to_nums for use in SQLite queries. Thanks, Simon Willison.

- Python 3.9a1 is supported.

- Coverage.py has a mascot: Sleepy Snake.

## Version 5.0b1 — 2019-11-11

- The HTML and textual reports now have a `--skip-empty` option that skips files with no statements, notably `__init__.py` files. Thanks, Reya B.

- Configuration can now be read from TOML files. This requires installing coverage.py with the `[toml]` extra. The standard “pyproject.toml” file will be read automatically if no other configuration file is found, with settings in the `[tool.coverage.]` namespace. Thanks to Frazer McLean for implementation and persistence. Finishes issue 664.

- The `[run] note` setting has been deprecated. Using it will result in a warning, and the note will not be written to the data file. The corresponding `CoverageData` methods have been removed.

- The HTML report has been reimplemented (no more table around the source code). This allowed for a better presentation of the context information, hopefully resolving issue 855.

- Added sqlite3 module version information to `coverage debug sys` output.

- Asking the HTML report to show contexts (`[html] show_contexts=True` or `coverage html --show-contexts`) will issue a warning if there were no contexts measured (issue 851).

## Version 5.0a8 — 2019-10-02

- The `CoverageData` API has changed how queries are limited to specific contexts. Now you use `CoverageData.set_query_context()` to set a single exact-match string, or `CoverageData.set_query_contexts()` to set a list of regular expressions to match contexts. This changes the command-line `--contexts` option to use regular expressions instead of filename-style wildcards.

## Version 5.0a7 — 2019-09-21

- Data can now be “reported” in JSON format, for programmatic use, as requested in issue 720. The new `coverage json` command writes raw and summarized data to a JSON file. Thanks, Matt Bachmann.

- Dynamic contexts are now supported in the Python tracer, which is important for PyPy users. Closes issue 846.

- The compact line number representation introduced in 5.0a6 is called a “numbits.” The `coverage.numbits` module provides functions for working with them.

- The reporting methods used to permanently apply their arguments to the configuration of the Coverage object. Now they no longer do. The arguments affect the operation of the method, but do not persist.

- A class named “test_something” no longer confuses the `test_function` dynamic context setting. Fixes issue 829.

- Fixed an unusual tokenizing issue with backslashes in comments. Fixes issue 822.

- `debug=plugin` didn’t properly support configuration or dynamic context plugins, but now it does, closing issue 834.

## Version 5.0a6 — 2019-07-16

- Reporting on contexts. Big thanks to Stephan Richter and Albertas Agejevas for the contribution.

  - The `--contexts` option is available on the `report` and `html` commands. It’s a comma-separated list of shell-style wildcards, selecting the contexts to report on. Only contexts matching one of the wildcards will be included in the report.

  - The `--show-contexts` option for the `html` command adds context information to each covered line. Hovering over the “ctx” marker at the end of the line reveals a list of the contexts that covered the line.

- Database changes:

  - Line numbers are now stored in a much more compact way. For each file and context, a single binary string is stored with a bit per line number. This greatly improves memory use, but makes ad-hoc use difficult.

  - Dynamic contexts with no data are no longer written to the database.

  - SQLite data storage is now faster. There’s no longer a reason to keep the JSON data file code, so it has been removed.

- Changes to the `CoverageData` interface:

  - The new `CoverageData.dumps()` method serializes the data to a string, and a corresponding `CoverageData.loads()` method reconstitutes this data. The format of the data string is subject to change at any time, and so should only be used between two installations of the same version of coverage.py.

  - The `CoverageData constructor` has a new argument, no_disk (default: False). Setting it to True prevents writing any data to the disk. This is useful for transient data objects.

- Added the class method `Coverage.current()` to get the latest started Coverage instance.

- Multiprocessing support in Python 3.8 was broken, but is now fixed. Closes issue 828.

- Error handling during reporting has changed slightly. All reporting methods now behave the same. The `--ignore-errors` option keeps errors from stopping the reporting, but files that couldn’t parse as Python will always be reported as warnings. As with other warnings, you can suppress them with the `[run] disable_warnings` configuration setting.

- Coverage.py no longer fails if the user program deletes its current directory. Fixes issue 806. Thanks, Dan Hemberger.

- The scrollbar markers in the HTML report now accurately show the highlighted lines, regardless of what categories of line are highlighted.

- The hack to accommodate ShiningPanda looking for an obsolete internal data file has been removed, since ShiningPanda 0.22 fixed it four years ago.

- The deprecated Reporter.file_reporters property has been removed.

## Version 5.0a5 — 2019-05-07

- Drop support for Python 3.4

- Dynamic contexts can now be set two new ways, both thanks to Justas Sadzevičius.

  - A plugin can implement a `dynamic_context` method to check frames for whether a new context should be started. See Dynamic Context Switchers for more details.

  - Another tool (such as a test runner) can use the new `Coverage.switch_context()` method to explicitly change the context.

- The `dynamic_context = test_function` setting now works with Python 2 old-style classes, though it only reports the method name, not the class it was defined on. Closes issue 797.

- `fail_under` values more than 100 are reported as errors. Thanks to Mike Fiedler for closing issue 746.

- The “missing” values in the text output are now sorted by line number, so that missing branches are reported near the other lines they affect. The values used to show all missing lines, and then all missing branches.

- Access to the SQLite database used for data storage is now thread-safe. Thanks, Stephan Richter. This closes issue 702.

- Combining data stored in SQLite is now about twice as fast, fixing issue 761. Thanks, Stephan Richter.

- The `filename` attribute on `CoverageData` objects has been made private. You can use the `data_filename` method to get the actual file name being used to store data, and the `base_filename` method to get the original filename before parallelizing suffixes were added. This is part of fixing issue 708.

- Line numbers in the HTML report now align properly with source lines, even when Chrome’s minimum font size is set, fixing issue 748. Thanks Wen Ye.

## Version 5.0a4 — 2018-11-25

- You can specify the command line to run your program with the `[run] command_line` configuration setting, as requested in issue 695.

- Coverage will create directories as needed for the data file if they don’t exist, closing issue 721.

- The `coverage run` command has always adjusted the first entry in sys.path, to properly emulate how Python runs your program. Now this adjustment is skipped if sys.path[0] is already different than Python’s default. This fixes issue 715.

- Improvements to context support:

  - The “no such table: meta” error is fixed.: issue 716.

  - Combining data files is now much faster.

- Python 3.8 (as of today!) passes all tests.

## Version 5.0a3 — 2018-10-06

- Context support: static contexts let you specify a label for a coverage run, which is recorded in the data, and retained when you combine files. See Measurement contexts for more information.

- Dynamic contexts: specifying `[run] dynamic_context = test_function` in the config file will record the test function name as a dynamic context during execution. This is the core of “Who Tests What” (issue 170). Things to note:

  - There is no reporting support yet. Use SQLite to query the .coverage file for information. Ideas are welcome about how reporting could be extended to use this data.

  - There’s a noticeable slow-down before any test is run.

  - Data files will now be roughly N times larger, where N is the number of tests you have. Combining data files is therefore also N times slower.

  - No other values for `dynamic_context` are recognized yet. Let me know what else would be useful. I’d like to use a pytest plugin to get better information directly from pytest, for example.

- Environment variable substitution in configuration files now supports two syntaxes for controlling the behavior of undefined variables: if `VARNAME` is not defined, `${VARNAME?}` will raise an error, and `${VARNAME-default value}` will use “default value”.

- Partial support for Python 3.8, which has not yet released an alpha. Fixes issue 707 and issue 714.

## Version 5.0a2 — 2018-09-03

- Coverage’s data storage has changed. In version 4.x, .coverage files were basically JSON. Now, they are SQLite databases. This means the data file can be created earlier than it used to. A large amount of code was refactored to support this change.

  - Because the data file is created differently than previous releases, you may need `parallel=true` where you didn’t before.

  - The old data format is still available (for now) by setting the environment variable `COVERAGE_STORAGE=json`. Please tell me if you think you need to keep the JSON format.

  - The database schema is guaranteed to change in the future, to support new features. I’m looking for opinions about making the schema part of the public API to coverage.py or not.

- Development moved from Bitbucket to GitHub.

- HTML files no longer have trailing and extra white space.

- The sort order in the HTML report is stored in local storage rather than cookies, closing issue 611. Thanks, Federico Bond.

- pickle2json, for converting v3 data files to v4 data files, has been removed.

## Version 5.0a1 — 2018-06-05

- Coverage.py no longer supports Python 2.6 or 3.3.

- The location of the configuration file can now be specified with a `COVERAGE_RCFILE` environment variable, as requested in issue 650.

- Namespace packages are supported on Python 3.7, where they used to cause TypeErrors about path being None. Fixes issue 700.

- A new warning (`already-imported`) is issued if measurable files have already been imported before coverage.py started measurement. See Warnings for more information.

- Running coverage many times for small runs in a single process should be faster, closing issue 625. Thanks, David MacIver.

- Large HTML report pages load faster. Thanks, Pankaj Pandey.

## Version 4.5.4 — 2019-07-29

- Multiprocessing support in Python 3.8 was broken, but is now fixed. Closes issue 828.

## Version 4.5.3 — 2019-03-09

- Only packaging metadata changes.

## Version 4.5.2 — 2018-11-12

- Namespace packages are supported on Python 3.7, where they used to cause TypeErrors about path being None. Fixes issue 700.

- Python 3.8 (as of today!) passes all tests. Fixes issue 707 and issue 714.

- Development moved from Bitbucket to GitHub.

## Version 4.5.1 — 2018-02-10

- Now that 4.5 properly separated the `[run] omit` and `[report] omit` settings, an old bug has become apparent. If you specified a package name for `[run] source`, then omit patterns weren’t matched inside that package. This bug (issue 638) is now fixed.

- On Python 3.7, reporting about a decorated function with no body other than a docstring would crash coverage.py with an IndexError (issue 640). This is now fixed.

- Configurer plugins are now reported in the output of `--debug=sys`.

## Version 4.5 — 2018-02-03

- A new kind of plugin is supported: configurers are invoked at start-up to allow more complex configuration than the .coveragerc file can easily do. See Plug-in classes for details. This solves the complex configuration problem described in issue 563.

- The `fail_under` option can now be a float. Note that you must specify the `[report] precision` configuration option for the fractional part to be used. Thanks to Lars Hupfeldt Nielsen for help with the implementation. Fixes issue 631.

- The `include` and `omit` options can be specified for both the `[run]` and `[report]` phases of execution. 4.4.2 introduced some incorrect interactions between those phases, where the options for one were confused for the other. This is now corrected, fixing issue 621 and issue 622. Thanks to Daniel Hahler for seeing more clearly than I could.

- The `coverage combine` command used to always overwrite the data file, even when no data had been read from apparently combinable files. Now, an error is raised if we thought there were files to combine, but in fact none of them could be used. Fixes issue 629.

- The `coverage combine` command could get confused about path separators when combining data collected on Windows with data collected on Linux, as described in issue 618. This is now fixed: the result path always uses the path separator specified in the `[paths]` result.

- On Windows, the HTML report could fail when source trees are deeply nested, due to attempting to create HTML filenames longer than the 250-character maximum. Now filenames will never get much larger than 200 characters, fixing issue 627. Thanks to Alex Sandro for helping with the fix.

## Version 4.4.2 — 2017-11-05

- Support for Python 3.7. In some cases, class and module docstrings are no longer counted in statement totals, which could slightly change your total results.

- Specifying both `--source` and `--include` no longer silently ignores the include setting, instead it displays a warning. Thanks, Loïc Dachary. Closes issue 265 and issue 101.

- Fixed a race condition when saving data and multiple threads are tracing (issue 581). It could produce a “dictionary changed size during iteration” RuntimeError. I believe this mostly but not entirely fixes the race condition. A true fix would likely be too expensive. Thanks, Peter Baughman for the debugging, and Olivier Grisel for the fix with tests.

- Configuration values which are file paths will now apply tilde-expansion, closing issue 589.

- Now secondary config files like tox.ini and setup.cfg can be specified explicitly, and prefixed sections like [coverage:run] will be read. Fixes issue 588.

- Be more flexible about the command name displayed by help, fixing issue 600. Thanks, Ben Finney.

## Version 4.4.1 — 2017-05-14

- No code changes: just corrected packaging for Python 2.7 Linux wheels.

## Version 4.4 — 2017-05-07

- Reports could produce the wrong file names for packages, reporting `pkg.py` instead of the correct `pkg/__init__.py`. This is now fixed. Thanks, Dirk Thomas.

- XML reports could produce `<source>` and `<class>` lines that together didn’t specify a valid source file path. This is now fixed. (issue 526)

- Namespace packages are no longer warned as having no code. (issue 572)

- Code that uses `sys.settrace(sys.gettrace())` in a file that wasn’t being coverage-measured would prevent correct coverage measurement in following code. An example of this was running doctests programmatically. This is now fixed. (issue 575)

- Errors printed by the `coverage` command now go to stderr instead of stdout.

- Running `coverage xml` in a directory named with non-ASCII characters would fail under Python 2. This is now fixed. (issue 573)

## Version 4.4b1 — 2017-04-04

- Some warnings can now be individually disabled. Warnings that can be disabled have a short name appended. The `[run] disable_warnings` setting takes a list of these warning names to disable. Closes both issue 96 and issue 355.

- The XML report now includes attributes from version 4 of the Cobertura XML format, fixing issue 570.

- In previous versions, calling a method that used collected data would prevent further collection. For example, save(), report(), html_report(), and others would all stop collection. An explicit start() was needed to get it going again. This is no longer true. Now you can use the collected data and also continue measurement. Both issue 79 and issue 448 described this problem, and have been fixed.

- Plugins can now find un-executed files if they choose, by implementing the find_executable_files method. Thanks, Emil Madsen.

- Minimal IronPython support. You should be able to run IronPython programs under `coverage run`, though you will still have to do the reporting phase with CPython.

- Coverage.py has long had a special hack to support CPython’s need to measure the coverage of the standard library tests. This code was not installed by kitted versions of coverage.py. Now it is.

## Version 4.3.4 — 2017-01-17

- Fixing 2.6 in version 4.3.3 broke other things, because the too-tricky exception wasn’t properly derived from Exception, described in issue 556. A newb mistake; it hasn’t been a good few days.

## Version 4.3.3 — 2017-01-17

- Python 2.6 support was broken due to a testing exception imported for the benefit of the coverage.py test suite. Properly conditionalizing it fixed issue 554 so that Python 2.6 works again.

## Version 4.3.2 — 2017-01-16

- Using the `--skip-covered` option on an HTML report with 100% coverage would cause a “No data to report” error, as reported in issue 549. This is now fixed; thanks, Loïc Dachary.

- If-statements can be optimized away during compilation, for example, if 0: or if __debug__:. Coverage.py had problems properly understanding these statements which existed in the source, but not in the compiled bytecode. This problem, reported in issue 522, is now fixed.

- If you specified `--source` as a directory, then coverage.py would look for importable Python files in that directory, and could identify ones that had never been executed at all. But if you specified it as a package name, that detection wasn’t performed. Now it is, closing issue 426. Thanks to Loïc Dachary for the fix.

- If you started and stopped coverage measurement thousands of times in your process, you could crash Python with a “Fatal Python error: deallocating None” error. This is now fixed. Thanks to Alex Groce for the bug report.

- On PyPy, measuring coverage in subprocesses could produce a warning: “Trace function changed, measurement is likely wrong: None”. This was spurious, and has been suppressed.

- Previously, coverage.py couldn’t start on Jython, due to that implementation missing the multiprocessing module (issue 551). This problem has now been fixed. Also, issue 322 about not being able to invoke coverage conveniently, seems much better: `jython -m coverage run myprog.py` works properly.

- Let’s say you ran the HTML report over and over again in the same output directory, with `--skip-covered`. And imagine due to your heroic test-writing efforts, a file just achieved the goal of 100% coverage. With coverage.py 4.3, the old HTML file with the less-than-100% coverage would be left behind. This file is now properly deleted.

## Version 4.3.1 — 2016-12-28

- Some environments couldn’t install 4.3, as described in issue 540. This is now fixed.

- The check for conflicting `--source` and `--include` was too simple in a few different ways, breaking a few perfectly reasonable use cases, described in issue 541. The check has been reverted while we re-think the fix for issue 265.

## Version 4.3 — 2016-12-27

Special thanks to Loïc Dachary, who took an extraordinary interest in coverage.py and contributed a number of improvements in this release.

- Subprocesses that are measured with automatic subprocess measurement used to read in any pre-existing data file. This meant data would be incorrectly carried forward from run to run. Now those files are not read, so each subprocess only writes its own data. Fixes issue 510.

- The `coverage combine` command will now fail if there are no data files to combine. The combine changes in 4.2 meant that multiple combines could lose data, leaving you with an empty .coverage data file. Fixes issue 525, issue 412, issue 516, and probably issue 511.

- Coverage.py wouldn’t execute sys.excepthook when an exception happened in your program. Now it does, thanks to Andrew Hoos. Closes issue 535.

- Branch coverage fixes:

  - Branch coverage could misunderstand a finally clause on a try block that never continued on to the following statement, as described in issue 493. This is now fixed. Thanks to Joe Doherty for the report and Loïc Dachary for the fix.

  - A while loop with a constant condition (while True) and a continue statement would be mis-analyzed, as described in issue 496. This is now fixed, thanks to a bug report by Eli Skeggs and a fix by Loïc Dachary.

  - While loops with constant conditions that were never executed could result in a non-zero coverage report. Artem Dayneko reported this in issue 502, and Loïc Dachary provided the fix.

- The HTML report now supports a `--skip-covered` option like the other reporting commands. Thanks, Loïc Dachary for the implementation, closing issue 433.

- Options can now be read from a tox.ini file, if any. Like setup.cfg, sections are prefixed with “coverage:”, so `[run]` options will be read from the `[coverage:run]` section of tox.ini. Implements part of issue 519. Thanks, Stephen Finucane.

- Specifying both `--source` and `--include` no longer silently ignores the include setting, instead it fails with a message. Thanks, Nathan Land and Loïc Dachary. Closes issue 265.

- The `Coverage.combine` method has a new parameter, `strict=False`, to support failing if there are no data files to combine.

- When forking subprocesses, the coverage data files would have the same random number appended to the file name. This didn’t cause problems, because the file names had the process id also, making collisions (nearly) impossible. But it was disconcerting. This is now fixed.

- The text report now properly sizes headers when skipping some files, fixing issue 524. Thanks, Anthony Sottile and Loïc Dachary.

- Coverage.py can now search .pex files for source, just as it can .zip and .egg. Thanks, Peter Ebden.

- Data files are now about 15% smaller.

- Improvements in the `[run] debug` setting:

  - The “dataio” debug setting now also logs when data files are deleted during combining or erasing.

  - A new debug option, “multiproc”, for logging the behavior of `concurrency=multiprocessing`.

  - If you used the debug options “config” and “callers” together, you’d get a call stack printed for every line in the multi-line config output. This is now fixed.

- Fixed an unusual bug involving multiple coding declarations affecting code containing code in multi-line strings: issue 529.

- Coverage.py will no longer be misled into thinking that a plain file is a package when interpreting `--source` options. Thanks, Cosimo Lupo.

- If you try to run a non-Python file with coverage.py, you will now get a more useful error message. Issue 514.

- The default pragma regex changed slightly, but this will only matter to you if you are deranged and use mixed-case pragmas.

- Deal properly with non-ASCII file names in an ASCII-only world, issue 533.

- Programs that set Unicode configuration values could cause UnicodeErrors when generating HTML reports. Pytest-cov is one example. This is now fixed.

- Prevented deprecation warnings from configparser that happened in some circumstances, closing issue 530.

- Corrected the name of the jquery.ba-throttle-debounce.js library. Thanks, Ben Finney. Closes issue 505.

- Testing against PyPy 5.6 and PyPy3 5.5.

- Switched to pytest from nose for running the coverage.py tests.

- Renamed AUTHORS.txt to CONTRIBUTORS.txt, since there are other ways to contribute than by writing code. Also put the count of contributors into the author string in setup.py, though this might be too cute.

## Version 4.2 — 2016-07-26

- Since `concurrency=multiprocessing` uses subprocesses, options specified on the coverage.py command line will not be communicated down to them. Only options in the configuration file will apply to the subprocesses. Previously, the options didn’t apply to the subprocesses, but there was no indication. Now it is an error to use `--concurrency=multiprocessing` and other run-affecting options on the command line. This prevents failures like those reported in issue 495.

- Filtering the HTML report is now faster, thanks to Ville Skyttä.

## Version 4.2b1 — 2016-07-04

Work from the PyCon 2016 Sprints!

- BACKWARD INCOMPATIBILITY: the `coverage combine` command now ignores an existing `.coverage` data file. It used to include that file in its combining. This caused confusing results, and extra tox “clean” steps. If you want the old behavior, use the new `coverage combine --append` option.

- The `concurrency` option can now take multiple values, to support programs using multiprocessing and another library such as eventlet. This is only possible in the configuration file, not from the command line. The configuration file is the only way for sub-processes to all run with the same options. Fixes issue 484. Thanks to Josh Williams for prototyping.

- Using a `concurrency` setting of `multiprocessing` now implies `--parallel` so that the main program is measured similarly to the sub-processes.

- When using automatic subprocess measurement, running coverage commands would create spurious data files. This is now fixed, thanks to diagnosis and testing by Dan Riti. Closes issue 492.

- A new configuration option, `report:sort`, controls what column of the text report is used to sort the rows. Thanks to Dan Wandschneider, this closes issue 199.

- The HTML report has a more-visible indicator for which column is being sorted. Closes issue 298, thanks to Josh Williams.

- If the HTML report cannot find the source for a file, the message now suggests using the `-i` flag to allow the report to continue. Closes issue 231, thanks, Nathan Land.

- When reports are ignoring errors, there’s now a warning if a file cannot be parsed, rather than being silently ignored. Closes issue 396. Thanks, Matthew Boehm.

- A new option for `coverage debug` is available: `coverage debug config` shows the current configuration. Closes issue 454, thanks to Matthew Boehm.

- Running coverage as a module (`python -m coverage`) no longer shows the program name as `__main__.py`. Fixes issue 478. Thanks, Scott Belden.

- The test_helpers module has been moved into a separate pip-installable package: unittest-mixins.

## Version 4.1 — 2016-05-21

- The internal attribute Reporter.file_reporters was removed in 4.1b3. It should have come has no surprise that there were third-party tools out there using that attribute. It has been restored, but with a deprecation warning.

## Version 4.1b3 — 2016-05-10

- When running your program, execution can jump from an `except X:` line to some other line when an exception other than `X` happens. This jump is no longer considered a branch when measuring branch coverage.

- When measuring branch coverage, `yield` statements that were never resumed were incorrectly marked as missing, as reported in issue 440. This is now fixed.

- During branch coverage of single-line callables like lambdas and generator expressions, coverage.py can now distinguish between them never being called, or being called but not completed. Fixes issue 90, issue 460 and issue 475.

- The HTML report now has a map of the file along the rightmost edge of the page, giving an overview of where the missed lines are. Thanks, Dmitry Shishov.

- The HTML report now uses different monospaced fonts, favoring Consolas over Courier. Along the way, issue 472 about not properly handling one-space indents was fixed. The index page also has slightly different styling, to try to make the clickable detail pages more apparent.

- Missing branches reported with `coverage report -m` will now say `->exit` for missed branches to the exit of a function, rather than a negative number. Fixes issue 469.

- `coverage --help` and `coverage --version` now mention which tracer is installed, to help diagnose problems. The docs mention which features need the C extension. (issue 479)

- Officially support PyPy 5.1, which required no changes, just updates to the docs.

- The Coverage.report function had two parameters with non-None defaults, which have been changed. show_missing used to default to True, but now defaults to None. If you had been calling Coverage.report without specifying show_missing, you’ll need to explicitly set it to True to keep the same behavior. skip_covered used to default to False. It is now None, which doesn’t change the behavior. This fixes issue 485.

- It’s never been possible to pass a namespace module to one of the analysis functions, but now at least we raise a more specific error message, rather than getting confused. (issue 456)

- The coverage.process_startup function now returns the Coverage instance it creates, as suggested in issue 481.

- Make a small tweak to how we compare threads, to avoid buggy custom comparison code in thread classes. (issue 245)

## Version 4.1b2 — 2016-01-23

- Problems with the new branch measurement in 4.1 beta 1 were fixed:

  - Class docstrings were considered executable. Now they no longer are.

  - `yield from` and `await` were considered returns from functions, since they could transfer control to the caller. This produced unhelpful “missing branch” reports in a number of circumstances. Now they no longer are considered returns.

  - In unusual situations, a missing branch to a negative number was reported. This has been fixed, closing issue 466.

- The XML report now produces correct package names for modules found in directories specified with `source=`. Fixes issue 465.

- `coverage report` won’t produce trailing white space.

## Version 4.1b1 — 2016-01-10

- Branch analysis has been rewritten: it used to be based on bytecode, but now uses AST analysis. This has changed a number of things:

  - More code paths are now considered runnable, especially in `try`/`except` structures. This may mean that coverage.py will identify more code paths as uncovered. This could either raise or lower your overall coverage number.

  - Python 3.5’s `async` and `await` keywords are properly supported, fixing issue 434.

  - Some long-standing branch coverage bugs were fixed:

    - issue 129: functions with only a docstring for a body would incorrectly report a missing branch on the `def` line.

    - issue 212: code in an `except` block could be incorrectly marked as a missing branch.

    - issue 146: context managers (`with` statements) in a loop or `try` block could confuse the branch measurement, reporting incorrect partial branches.

    - issue 422: in Python 3.5, an actual partial branch could be marked as complete.

- Pragmas to disable coverage measurement can now be used on decorator lines, and they will apply to the entire function or class being decorated. This implements the feature requested in issue 131.

- Multiprocessing support is now available on Windows. Thanks, Rodrigue Cloutier.

- Files with two encoding declarations are properly supported, fixing issue 453. Thanks, Max Linke.

- Non-ascii characters in regexes in the configuration file worked in 3.7, but stopped working in 4.0. Now they work again, closing issue 455.

- Form-feed characters would prevent accurate determination of the beginning of statements in the rest of the file. This is now fixed, closing issue 461.

## Version 4.0.3 — 2015-11-24

- Fixed a mysterious problem that manifested in different ways: sometimes hanging the process (issue 420), sometimes making database connections fail (issue 445).

- The XML report now has correct `<source>` elements when using a `--source=` option somewhere besides the current directory. This fixes issue 439. Thanks, Arcadiy Ivanov.

- Fixed an unusual edge case of detecting source encodings, described in issue 443.

- Help messages that mention the command to use now properly use the actual command name, which might be different than “coverage”. Thanks to Ben Finney, this closes issue 438.

## Version 4.0.2 — 2015-11-04

- More work on supporting unusually encoded source. Fixed issue 431.

- Files or directories with non-ASCII characters are now handled properly, fixing issue 432.

- Setting a trace function with sys.settrace was broken by a change in 4.0.1, as reported in issue 436. This is now fixed.

- Officially support PyPy 4.0, which required no changes, just updates to the docs.

## Version 4.0.1 — 2015-10-13

- When combining data files, unreadable files will now generate a warning instead of failing the command. This is more in line with the older coverage.py v3.7.1 behavior, which silently ignored unreadable files. Prompted by issue 418.

- The –skip-covered option would skip reporting on 100% covered files, but also skipped them when calculating total coverage. This was wrong, it should only remove lines from the report, not change the final answer. This is now fixed, closing issue 423.

- In 4.0, the data file recorded a summary of the system on which it was run. Combined data files would keep all of those summaries. This could lead to enormous data files consisting of mostly repetitive useless information. That summary is now gone, fixing issue 415. If you want summary information, get in touch, and we’ll figure out a better way to do it.

- Test suites that mocked os.path.exists would experience strange failures, due to coverage.py using their mock inadvertently. This is now fixed, closing issue 416.

- Importing a `__init__` module explicitly would lead to an error: `AttributeError: 'module' object has no attribute '__path__'`, as reported in issue 410. This is now fixed.

- Code that uses `sys.settrace(sys.gettrace())` used to incur a more than 2x speed penalty. Now there’s no penalty at all. Fixes issue 397.

- Pyexpat C code will no longer be recorded as a source file, fixing issue 419.

- The source kit now contains all of the files needed to have a complete source tree, re-fixing issue 137 and closing issue 281.

## Version 4.0 — 2015-09-20

No changes from 4.0b3

## Version 4.0b3 — 2015-09-07

- Reporting on an unmeasured file would fail with a traceback. This is now fixed, closing issue 403.

- The Jenkins ShiningPanda plugin looks for an obsolete file name to find the HTML reports to publish, so it was failing under coverage.py 4.0. Now we create that file if we are running under Jenkins, to keep things working smoothly. issue 404.

- Kits used to include tests and docs, but didn’t install them anywhere, or provide all of the supporting tools to make them useful. Kits no longer include tests and docs. If you were using them from the older packages, get in touch and help me understand how.

## Version 4.0b2 — 2015-08-22

- 4.0b1 broke `--append` creating new data files. This is now fixed, closing issue 392.

- `py.test --cov` can write empty data, then touch files due to `--source`, which made coverage.py mistakenly force the data file to record lines instead of arcs. This would lead to a “Can’t combine line data with arc data” error message. This is now fixed, and changed some method names in the CoverageData interface. Fixes issue 399.

- CoverageData.read_fileobj and CoverageData.write_fileobj replace the .read and .write methods, and are now properly inverses of each other.

- When using `report --skip-covered`, a message will now be included in the report output indicating how many files were skipped, and if all files are skipped, coverage.py won’t accidentally scold you for having no data to report. Thanks, Krystian Kichewko.

- A new conversion utility has been added: `python -m coverage.pickle2json` will convert v3.x pickle data files to v4.x JSON data files. Thanks, Alexander Todorov. Closes issue 395.

- A new version identifier is available, coverage.version_info, a plain tuple of values similar to sys.version_info.

## Version 4.0b1 — 2015-08-02

- Coverage.py is now licensed under the Apache 2.0 license. See NOTICE.txt for details. Closes issue 313.

- The data storage has been completely revamped. The data file is now JSON-based instead of a pickle, closing issue 236. The CoverageData class is now a public supported documented API to the data file.

- A new configuration option, `[run] note`, lets you set a note that will be stored in the runs section of the data file. You can use this to annotate the data file with any information you like.

- Unrecognized configuration options will now print an error message and stop coverage.py. This should help prevent configuration mistakes from passing silently. Finishes issue 386.

- In parallel mode, `coverage erase` will now delete all of the data files, fixing issue 262.

- Coverage.py now accepts a directory name for `coverage run` and will run a `__main__.py` found there, just like Python will. Fixes issue 252. Thanks, Dmitry Trofimov.

- The XML report now includes a `missing-branches` attribute. Thanks, Steve Peak. This is not a part of the Cobertura DTD, so the XML report no longer references the DTD.

- Missing branches in the HTML report now have a bit more information in the right-hand annotations. Hopefully this will make their meaning clearer.

- All the reporting functions now behave the same if no data had been collected, exiting with a status code of 1. Fixed `fail_under` to be applied even when the report is empty. Thanks, Ionel Cristian Mărieș.

- Plugins are now initialized differently. Instead of looking for a class called `Plugin`, coverage.py looks for a function called `coverage_init`.

- A file-tracing plugin can now ask to have built-in Python reporting by returning “python” from its file_reporter() method.

- Code that was executed with exec would be mis-attributed to the file that called it. This is now fixed, closing issue 380.

- The ability to use item access on Coverage.config (introduced in 4.0a2) has been changed to a more explicit Coverage.get_option and Coverage.set_option API.

- The `Coverage.use_cache` method is no longer supported.

- The private method `Coverage._harvest_data` is now called `Coverage.get_data`, and returns the `CoverageData` containing the collected data.

- The project is consistently referred to as “coverage.py” throughout the code and the documentation, closing issue 275.

- Combining data files with an explicit configuration file was broken in 4.0a6, but now works again, closing issue 385.

- `coverage combine` now accepts files as well as directories.

- The speed is back to 3.7.1 levels, after having slowed down due to plugin support, finishing up issue 387.

## Version 4.0a6 — 2015-06-21

- Python 3.5b2 and PyPy 2.6.0 are supported.

- The original module-level function interface to coverage.py is no longer supported. You must now create a `coverage.Coverage` object, and use methods on it.

- The `coverage combine` command now accepts any number of directories as arguments, and will combine all the data files from those directories. This means you don’t have to copy the files to one directory before combining. Thanks, Christine Lytwynec. Finishes issue 354.

- Branch coverage couldn’t properly handle certain extremely long files. This is now fixed (issue 359).

- Branch coverage didn’t understand yield statements properly. Mickie Betz persisted in pursuing this despite Ned’s pessimism. Fixes issue 308 and issue 324.

- The `COVERAGE_DEBUG` environment variable can be used to set the `[run] debug` configuration option to control what internal operations are logged.

- HTML reports were truncated at formfeed characters. This is now fixed (issue 360). It’s always fun when the problem is due to a bug in the Python standard library.

- Files with incorrect encoding declaration comments are no longer ignored by the reporting commands, fixing issue 351.

- HTML reports now include a time stamp in the footer, closing issue 299. Thanks, Conrad Ho.

- HTML reports now begrudgingly use double-quotes rather than single quotes, because there are “software engineers” out there writing tools that read HTML and somehow have no idea that single quotes exist. Capitulates to the absurd issue 361. Thanks, Jon Chappell.

- The `coverage annotate` command now handles non-ASCII characters properly, closing issue 363. Thanks, Leonardo Pistone.

- Drive letters on Windows were not normalized correctly, now they are. Thanks, Ionel Cristian Mărieș.

- Plugin support had some bugs fixed, closing issue 374 and issue 375. Thanks, Stefan Behnel.

## Version 4.0a5 — 2015-02-16

- Plugin support is now implemented in the C tracer instead of the Python tracer. This greatly improves the speed of tracing projects using plugins.

- Coverage.py now always adds the current directory to sys.path, so that plugins can import files in the current directory (issue 358).

- If the config_file argument to the Coverage constructor is specified as “.coveragerc”, it is treated as if it were True. This means setup.cfg is also examined, and a missing file is not considered an error (issue 357).

- Wildly experimental: support for measuring processes started by the multiprocessing module. To use, set `--concurrency=multiprocessing`, either on the command line or in the .coveragerc file (issue 117). Thanks, Eduardo Schettino. Currently, this does not work on Windows.

- A new warning is possible, if a desired file isn’t measured because it was imported before coverage.py was started (issue 353).

- The coverage.process_startup function now will start coverage measurement only once, no matter how many times it is called. This fixes problems due to unusual virtualenv configurations (issue 340).

- Added 3.5.0a1 to the list of supported CPython versions.

## Version 4.0a4 — 2015-01-25

- Plugins can now provide sys_info for debugging output.

- Started plugins documentation.

- Prepared to move the docs to readthedocs.org.

## Version 4.0a3 — 2015-01-20

- Reports now use file names with extensions. Previously, a report would describe a/b/c.py as “a/b/c”. Now it is shown as “a/b/c.py”. This allows for better support of non-Python files, and also fixed issue 69.

- The XML report now reports each directory as a package again. This was a bad regression, I apologize. This was reported in issue 235, which is now fixed.

- A new configuration option for the XML report: `[xml] package_depth` controls which directories are identified as packages in the report. Directories deeper than this depth are not reported as packages. The default is that all directories are reported as packages. Thanks, Lex Berezhny.

- When looking for the source for a frame, check if the file exists. On Windows, .pyw files are no longer recorded as .py files. Along the way, this fixed issue 290.

- Empty files are now reported as 100% covered in the XML report, not 0% covered (issue 345).

- Regexes in the configuration file are now compiled as soon as they are read, to provide error messages earlier (issue 349).

## Version 4.0a2 — 2015-01-14

- Officially support PyPy 2.4, and PyPy3 2.4. Drop support for CPython 3.2 and older versions of PyPy. The code won’t work on CPython 3.2. It will probably still work on older versions of PyPy, but I’m not testing against them.

- Plugins!

- The original command line switches (-x to run a program, etc) are no longer supported.

- A new option: coverage report –skip-covered will reduce the number of files reported by skipping files with 100% coverage. Thanks, Krystian Kichewko. This means that empty __init__.py files will be skipped, since they are 100% covered, closing issue 315.

- You can now specify the `--fail-under` option in the `.coveragerc` file as the `[report] fail_under` option. This closes issue 314.

- The `COVERAGE_OPTIONS` environment variable is no longer supported. It was a hack for `--timid` before configuration files were available.

- The HTML report now has filtering. Type text into the Filter box on the index page, and only modules with that text in the name will be shown. Thanks, Danny Allen.

- The textual report and the HTML report used to report partial branches differently for no good reason. Now the text report’s “missing branches” column is a “partial branches” column so that both reports show the same numbers. This closes issue 342.

- If you specify a `--rcfile` that cannot be read, you will get an error message. Fixes issue 343.

- The `--debug` switch can now be used on any command.

- You can now programmatically adjust the configuration of coverage.py by setting items on Coverage.config after construction.

- A module run with `-m` can be used as the argument to `--source`, fixing issue 328. Thanks, Buck Evan.

- The regex for matching exclusion pragmas has been fixed to allow more kinds of white space, fixing issue 334.

- Made some PyPy-specific tweaks to improve speed under PyPy. Thanks, Alex Gaynor.

- In some cases, with a source file missing a final newline, coverage.py would count statements incorrectly. This is now fixed, closing issue 293.

- The status.dat file that HTML reports use to avoid re-creating files that haven’t changed is now a JSON file instead of a pickle file. This obviates issue 287 and issue 237.

## Version 4.0a1 — 2014-09-27

- Python versions supported are now CPython 2.6, 2.7, 3.2, 3.3, and 3.4, and PyPy 2.2.

- Gevent, eventlet, and greenlet are now supported, closing issue 149. The `concurrency` setting specifies the concurrency library in use. Huge thanks to Peter Portante for initial implementation, and to Joe Jevnik for the final insight that completed the work.

- Options are now also read from a setup.cfg file, if any. Sections are prefixed with “coverage:”, so the `[run]` options will be read from the `[coverage:run]` section of setup.cfg. Finishes issue 304.

- The `report -m` command can now show missing branches when reporting on branch coverage. Thanks, Steve Leonard. Closes issue 230.

- The XML report now contains a <source> element, fixing issue 94. Thanks Stan Hu.

- The class defined in the coverage module is now called `Coverage` instead of `coverage`, though the old name still works, for backward compatibility.

- The `fail-under` value is now rounded the same as reported results, preventing paradoxical results, fixing issue 284.

- The XML report will now create the output directory if need be, fixing issue 285. Thanks, Chris Rose.

- HTML reports no longer raise UnicodeDecodeError if a Python file has un-decodable characters, fixing issue 303 and issue 331.

- The annotate command will now annotate all files, not just ones relative to the current directory, fixing issue 57.

- The coverage module no longer causes deprecation warnings on Python 3.4 by importing the imp module, fixing issue 305.

- Encoding declarations in source files are only considered if they are truly comments. Thanks, Anthony Sottile.

## Version 3.7.1 — 2013-12-13

- Improved the speed of HTML report generation by about 20%.

- Fixed the mechanism for finding OS-installed static files for the HTML report so that it will actually find OS-installed static files.

## Version 3.7 — 2013-10-06

- Added the `--debug` switch to `coverage run`. It accepts a list of options indicating the type of internal activity to log to stderr.

- Improved the branch coverage facility, fixing issue 92 and issue 175.

- Running code with `coverage run -m` now behaves more like Python does, setting sys.path properly, which fixes issue 207 and issue 242.

- Coverage.py can now run .pyc files directly, closing issue 264.

- Coverage.py properly supports .pyw files, fixing issue 261.

- Omitting files within a tree specified with the `source` option would cause them to be incorrectly marked as un-executed, as described in issue 218. This is now fixed.

- When specifying paths to alias together during data combining, you can now specify relative paths, fixing issue 267.

- Most file paths can now be specified with username expansion (`~/src`, or `~build/src`, for example), and with environment variable expansion (`build/$BUILDNUM/src`).

- Trying to create an XML report with no files to report on, would cause a ZeroDivisionError, but no longer does, fixing issue 250.

- When running a threaded program under the Python tracer, coverage.py no longer issues a spurious warning about the trace function changing: “Trace function changed, measurement is likely wrong: None.” This fixes issue 164.

- Static files necessary for HTML reports are found in system-installed places, to ease OS-level packaging of coverage.py. Closes issue 259.

- Source files with encoding declarations, but a blank first line, were not decoded properly. Now they are. Thanks, Roger Hu.

- The source kit now includes the `__main__.py` file in the root coverage directory, fixing issue 255.

## Version 3.6 — 2013-01-05

- Added a page to the docs about troublesome situations, closing issue 226, and added some info to the TODO file, closing issue 227.

## Version 3.6b3 — 2012-12-29

- Beta 2 broke the nose plugin. It’s fixed again, closing issue 224.

## Version 3.6b2 — 2012-12-23

- Coverage.py runs on Python 2.3 and 2.4 again. It was broken in 3.6b1.

- The C extension is optionally compiled using a different more widely-used technique, taking another stab at fixing issue 80 once and for all.

- Combining data files would create entries for phantom files if used with `source` and path aliases. It no longer does.

- `debug sys` now shows the configuration file path that was read.

- If an oddly-behaved package claims that code came from an empty-string file name, coverage.py no longer associates it with the directory name, fixing issue 221.

## Version 3.6b1 — 2012-11-28

- Wildcards in `include=` and `omit=` arguments were not handled properly in reporting functions, though they were when running. Now they are handled uniformly, closing issue 143 and issue 163. NOTE: it is possible that your configurations may now be incorrect. If you use `include` or `omit` during reporting, whether on the command line, through the API, or in a configuration file, please check carefully that you were not relying on the old broken behavior.

- The report, html, and xml commands now accept a `--fail-under` switch that indicates in the exit status whether the coverage percentage was less than a particular value. Closes issue 139.

- The reporting functions coverage.report(), coverage.html_report(), and coverage.xml_report() now all return a float, the total percentage covered measurement.

- The HTML report’s title can now be set in the configuration file, with the `--title` switch on the command line, or via the API.

- Configuration files now support substitution of environment variables, using syntax like `${WORD}`. Closes issue 97.

- Embarrassingly, the `[xml] output=` setting in the .coveragerc file simply didn’t work. Now it does.

- The XML report now consistently uses file names for the file name attribute, rather than sometimes using module names. Fixes issue 67. Thanks, Marcus Cobden.

- Coverage percentage metrics are now computed slightly differently under branch coverage. This means that completely un-executed files will now correctly have 0% coverage, fixing issue 156. This also means that your total coverage numbers will generally now be lower if you are measuring branch coverage.

- When installing, now in addition to creating a “coverage” command, two new aliases are also installed. A “coverage2” or “coverage3” command will be created, depending on whether you are installing in Python 2.x or 3.x. A “coverage-X.Y” command will also be created corresponding to your specific version of Python. Closes issue 111.

- The coverage.py installer no longer tries to bootstrap setuptools or Distribute. You must have one of them installed first, as issue 202 recommended.

- The coverage.py kit now includes docs (closing issue 137) and tests.

- On Windows, files are now reported in their correct case, fixing issue 89 and issue 203.

- If a file is missing during reporting, the path shown in the error message is now correct, rather than an incorrect path in the current directory. Fixes issue 60.

- Running an HTML report in Python 3 in the same directory as an old Python 2 HTML report would fail with a UnicodeDecodeError. This issue (issue 193) is now fixed.

- Fixed yet another error trying to parse non-Python files as Python, this time an IndentationError, closing issue 82 for the fourth time…

- If coverage xml fails because there is no data to report, it used to create a zero-length XML file. Now it doesn’t, fixing issue 210.

- Jython files now work with the `--source` option, fixing issue 100.

- Running coverage.py under a debugger is unlikely to work, but it shouldn’t fail with “TypeError: ‘NoneType’ object is not iterable”. Fixes issue 201.

- On some Linux distributions, when installed with the OS package manager, coverage.py would report its own code as part of the results. Now it won’t, fixing issue 214, though this will take some time to be repackaged by the operating systems.

- Docstrings for the legacy singleton methods are more helpful. Thanks Marius Gedminas. Closes issue 205.

- The pydoc tool can now show documentation for the class coverage.coverage. Closes issue 206.

- Added a page to the docs about contributing to coverage.py, closing issue 171.

- When coverage.py ended unsuccessfully, it may have reported odd errors like `'NoneType' object has no attribute 'isabs'`. It no longer does, so kiss issue 153 goodbye.

## Version 3.5.3 — 2012-09-29

- Line numbers in the HTML report line up better with the source lines, fixing issue 197, thanks Marius Gedminas.

- When specifying a directory as the source= option, the directory itself no longer needs to have a `__init__.py` file, though its sub-directories do, to be considered as source files.

- Files encoded as UTF-8 with a BOM are now properly handled, fixing issue 179. Thanks, Pablo Carballo.

- Fixed more cases of non-Python files being reported as Python source, and then not being able to parse them as Python. Closes issue 82 (again). Thanks, Julian Berman.

- Fixed memory leaks under Python 3, thanks, Brett Cannon. Closes issue 147.

- Optimized .pyo files may not have been handled correctly, issue 195. Thanks, Marius Gedminas.

- Certain unusually named file paths could have been mangled during reporting, issue 194. Thanks, Marius Gedminas.

- Try to do a better job of the impossible task of detecting when we can’t build the C extension, fixing issue 183.

- Testing is now done with tox, thanks, Marc Abramowitz.

## Version 3.5.2 — 2012-05-04

No changes since 3.5.2.b1

## Version 3.5.2b1 — 2012-04-29

- The HTML report has slightly tweaked controls: the buttons at the top of the page are color-coded to the source lines they affect.

- Custom CSS can be applied to the HTML report by specifying a CSS file as the `extra_css` configuration value in the `[html]` section.

- Source files with custom encodings declared in a comment at the top are now properly handled during reporting on Python 2. Python 3 always handled them properly. This fixes issue 157.

- Backup files left behind by editors are no longer collected by the source= option, fixing issue 168.

- If a file doesn’t parse properly as Python, we don’t report it as an error if the file name seems like maybe it wasn’t meant to be Python. This is a pragmatic fix for issue 82.

- The `-m` switch on `coverage report`, which includes missing line numbers in the summary report, can now be specified as `show_missing` in the config file. Closes issue 173.

- When running a module with `coverage run -m <modulename>`, certain details of the execution environment weren’t the same as for `python -m <modulename>`. This had the unfortunate side-effect of making `coverage run -m unittest discover` not work if you had tests in a directory named “test”. This fixes issue 155 and issue 142.

- Now the exit status of your product code is properly used as the process status when running `python -m coverage run ...`. Thanks, JT Olds.

- When installing into PyPy, we no longer attempt (and fail) to compile the C tracer function, closing issue 166.

## Version 3.5.1 — 2011-09-23

- The `[paths]` feature unfortunately didn’t work in real world situations where you wanted to, you know, report on the combined data. Now all paths stored in the combined file are canonicalized properly.

## Version 3.5.1b1 — 2011-08-28

- When combining data files from parallel runs, you can now instruct coverage.py about which directories are equivalent on different machines. A `[paths]` section in the configuration file lists paths that are to be considered equivalent. Finishes issue 17.

- for-else constructs are understood better, and don’t cause erroneous partial branch warnings. Fixes issue 122.

- Branch coverage for `with` statements is improved, fixing issue 128.

- The number of partial branches reported on the HTML summary page was different than the number reported on the individual file pages. This is now fixed.

- An explicit include directive to measure files in the Python installation wouldn’t work because of the standard library exclusion. Now the include directive takes precedence, and the files will be measured. Fixes issue 138.

- The HTML report now handles Unicode characters in Python source files properly. This fixes issue 124 and issue 144. Thanks, Devin Jeanpierre.

- In order to help the core developers measure the test coverage of the standard library, Brandon Rhodes devised an aggressive hack to trick Python into running some coverage.py code before anything else in the process. See the coverage/fullcoverage directory if you are interested.

## Version 3.5 — 2011-06-29

- The HTML report hotkeys now behave slightly differently when the current chunk isn’t visible at all: a chunk on the screen will be selected, instead of the old behavior of jumping to the literal next chunk. The hotkeys now work in Google Chrome. Thanks, Guido van Rossum.

## Version 3.5b1 — 2011-06-05

- The HTML report now has hotkeys. Try `n`, `s`, `m`, `x`, `b`, `p`, and `c` on the overview page to change the column sorting. On a file page, `r`, `m`, `x`, and `p` toggle the run, missing, excluded, and partial line markings. You can navigate the highlighted sections of code by using the `j` and `k` keys for next and previous. The `1` (one) key jumps to the first highlighted section in the file, and `0` (zero) scrolls to the top of the file.

- The `--omit` and `--include` switches now interpret their values more usefully. If the value starts with a wildcard character, it is used as-is. If it does not, it is interpreted relative to the current directory. Closes issue 121.

- Partial branch warnings can now be pragma’d away. The configuration option `partial_branches` is a list of regular expressions. Lines matching any of those expressions will never be marked as a partial branch. In addition, there’s a built-in list of regular expressions marking statements which should never be marked as partial. This list includes `while True:`, `while 1:`, `if 1:`, and `if 0:`.

- The `coverage()` constructor accepts single strings for the `omit=` and `include=` arguments, adapting to a common error in programmatic use.

- Modules can now be run directly using `coverage run -m modulename`, to mirror Python’s `-m` flag. Closes issue 95, thanks, Brandon Rhodes.

- `coverage run` didn’t emulate Python accurately in one small detail: the current directory inserted into `sys.path` was relative rather than absolute. This is now fixed.

- HTML reporting is now incremental: a record is kept of the data that produced the HTML reports, and only files whose data has changed will be generated. This should make most HTML reporting faster.

- Pathological code execution could disable the trace function behind our backs, leading to incorrect code measurement. Now if this happens, coverage.py will issue a warning, at least alerting you to the problem. Closes issue 93. Thanks to Marius Gedminas for the idea.

- The C-based trace function now behaves properly when saved and restored with `sys.gettrace()` and `sys.settrace()`. This fixes issue 125 and issue 123. Thanks, Devin Jeanpierre.

- Source files are now opened with Python 3.2’s `tokenize.open()` where possible, to get the best handling of Python source files with encodings. Closes issue 107, thanks, Brett Cannon.

- Syntax errors in supposed Python files can now be ignored during reporting with the `-i` switch just like other source errors. Closes issue 115.

- Installation from source now succeeds on machines without a C compiler, closing issue 80.

- Coverage.py can now be run directly from a working tree by specifying the directory name to python: `python coverage_py_working_dir run ...`. Thanks, Brett Cannon.

- A little bit of Jython support: coverage run can now measure Jython execution by adapting when $py.class files are traced. Thanks, Adi Roiban. Jython still doesn’t provide the Python libraries needed to make coverage reporting work, unfortunately.

- Internally, files are now closed explicitly, fixing issue 104. Thanks, Brett Cannon.

## Version 3.4 — 2010-09-19

- The XML report is now sorted by package name, fixing issue 88.

- Programs that exited with `sys.exit()` with no argument weren’t handled properly, producing a coverage.py stack trace. That is now fixed.

## Version 3.4b2 — 2010-09-06

- Completely un-executed files can now be included in coverage results, reported as 0% covered. This only happens if the –source option is specified, since coverage.py needs guidance about where to look for source files.

- The XML report output now properly includes a percentage for branch coverage, fixing issue 65 and issue 81.

- Coverage percentages are now displayed uniformly across reporting methods. Previously, different reports could round percentages differently. Also, percentages are only reported as 0% or 100% if they are truly 0 or 100, and are rounded otherwise. Fixes issue 41 and issue 70.

- The precision of reported coverage percentages can be set with the `[report] precision` config file setting. Completes issue 16.

- Threads derived from `threading.Thread` with an overridden run method would report no coverage for the run method. This is now fixed, closing issue 85.

## Version 3.4b1 — 2010-08-21

- BACKWARD INCOMPATIBILITY: the `--omit` and `--include` switches now take file patterns rather than file prefixes, closing issue 34 and issue 36.

- BACKWARD INCOMPATIBILITY: the omit_prefixes argument is gone throughout coverage.py, replaced with omit, a list of file name patterns suitable for fnmatch. A parallel argument include controls what files are included.

- The run command now has a `--source` switch, a list of directories or module names. If provided, coverage.py will only measure execution in those source files.

- Various warnings are printed to stderr for problems encountered during data measurement: if a `--source` module has no Python source to measure, or is never encountered at all, or if no data is collected.

- The reporting commands (report, annotate, html, and xml) now have an `--include` switch to restrict reporting to modules matching those file patterns, similar to the existing `--omit` switch. Thanks, Zooko.

- The run command now supports `--include` and `--omit` to control what modules it measures. This can speed execution and reduce the amount of data during reporting. Thanks Zooko.

- Since coverage.py 3.1, using the Python trace function has been slower than it needs to be. A cache of tracing decisions was broken, but has now been fixed.

- Python 2.7 and 3.2 have introduced new opcodes that are now supported.

- Python files with no statements, for example, empty `__init__.py` files, are now reported as having zero statements instead of one. Fixes issue 1.

- Reports now have a column of missed line counts rather than executed line counts, since developers should focus on reducing the missed lines to zero, rather than increasing the executed lines to varying targets. Once suggested, this seemed blindingly obvious.

- Line numbers in HTML source pages are clickable, linking directly to that line, which is highlighted on arrival. Added a link back to the index page at the bottom of each HTML page.

- Programs that call `os.fork` will properly collect data from both the child and parent processes. Use `coverage run -p` to get two data files that can be combined with `coverage combine`. Fixes issue 56.

- Coverage.py is now runnable as a module: `python -m coverage`. Thanks, Brett Cannon.

- When measuring code running in a virtualenv, most of the system library was being measured when it shouldn’t have been. This is now fixed.

- Doctest text files are no longer recorded in the coverage data, since they can’t be reported anyway. Fixes issue 52 and issue 61.

- Jinja HTML templates compile into Python code using the HTML file name, which confused coverage.py. Now these files are no longer traced, fixing issue 82.

- Source files can have more than one dot in them (foo.test.py), and will be treated properly while reporting. Fixes issue 46.

- Source files with DOS line endings are now properly tokenized for syntax coloring on non-DOS machines. Fixes issue 53.

- Unusual code structure that confused exits from methods with exits from classes is now properly analyzed. See issue 62.

- Asking for an HTML report with no files now shows a nice error message rather than a cryptic failure (‘int’ object is unsubscriptable). Fixes issue 59.

## Version 3.3.1 — 2010-03-06

- Using parallel=True in .coveragerc file prevented reporting, but now does not, fixing issue 49.

- When running your code with “coverage run”, if you call sys.exit(), coverage.py will exit with that status code, fixing issue 50.

## Version 3.3 — 2010-02-24

- Settings are now read from a .coveragerc file. A specific file can be specified on the command line with –rcfile=FILE. The name of the file can be programmatically set with the config_file argument to the coverage() constructor, or reading a config file can be disabled with config_file=False.

- Fixed a problem with nested loops having their branch possibilities mis-characterized: issue 39.

- Added coverage.process_start to enable coverage measurement when Python starts.

- Parallel data file names now have a random number appended to them in addition to the machine name and process id.

- Parallel data files combined with “coverage combine” are deleted after they’re combined, to clean up unneeded files. Fixes issue 40.

- Exceptions thrown from product code run with “coverage run” are now displayed without internal coverage.py frames, so the output is the same as when the code is run without coverage.py.

- The data_suffix argument to the coverage constructor is now appended with an added dot rather than simply appended, so that .coveragerc files will not be confused for data files.

- Python source files that don’t end with a newline can now be executed, fixing issue 47.

- Added an AUTHORS.txt file.

## Version 3.2 — 2009-12-05

- Added a `--version` option on the command line.

## Version 3.2b4 — 2009-12-01

- Branch coverage improvements:

  - The XML report now includes branch information.

- Click-to-sort HTML report columns are now persisted in a cookie. Viewing a report will sort it first the way you last had a coverage report sorted. Thanks, Chris Adams.

- On Python 3.x, setuptools has been replaced by Distribute.

## Version 3.2b3 — 2009-11-23

- Fixed a memory leak in the C tracer that was introduced in 3.2b1.

- Branch coverage improvements:

  - Branches to excluded code are ignored.

- The table of contents in the HTML report is now sortable: click the headers on any column. Thanks, Chris Adams.

## Version 3.2b2 — 2009-11-19

- Branch coverage improvements:

  - Classes are no longer incorrectly marked as branches: issue 32.

  - “except” clauses with types are no longer incorrectly marked as branches: issue 35.

- Fixed some problems syntax coloring sources with line continuations and source with tabs: issue 30 and issue 31.

- The –omit option now works much better than before, fixing issue 14 and issue 33. Thanks, Danek Duvall.

## Version 3.2b1 — 2009-11-10

- Branch coverage!

- XML reporting has file paths that let Cobertura find the source code.

- The tracer code has changed, it’s a few percent faster.

- Some exceptions reported by the command line interface have been cleaned up so that tracebacks inside coverage.py aren’t shown. Fixes issue 23.

## Version 3.1 — 2009-10-04

- Source code can now be read from eggs. Thanks, Ross Lawley. Fixes issue 25.

## Version 3.1b1 — 2009-09-27

- Python 3.1 is now supported.

- Coverage.py has a new command line syntax with sub-commands. This expands the possibilities for adding features and options in the future. The old syntax is still supported. Try “coverage help” to see the new commands. Thanks to Ben Finney for early help.

- Added an experimental “coverage xml” command for producing coverage reports in a Cobertura-compatible XML format. Thanks, Bill Hart.

- Added the –timid option to enable a simpler slower trace function that works for DecoratorTools projects, including TurboGears. Fixed issue 12 and issue 13.

- HTML reports show modules from other directories. Fixed issue 11.

- HTML reports now display syntax-colored Python source.

- Programs that change directory will still write .coverage files in the directory where execution started. Fixed issue 24.

- Added a “coverage debug” command for getting diagnostic information about the coverage.py installation.

## Version 3.0.1 — 2009-07-07

- Removed the recursion limit in the tracer function. Previously, code that ran more than 500 frames deep would crash. Fixed issue 9.

- Fixed a bizarre problem involving pyexpat, whereby lines following XML parser invocations could be overlooked. Fixed issue 10.

- On Python 2.3, coverage.py could mis-measure code with exceptions being raised. This is now fixed.

- The coverage.py code itself will now not be measured by coverage.py, and no coverage.py modules will be mentioned in the nose –with-cover plug-in. Fixed issue 8.

- When running source files, coverage.py now opens them in universal newline mode just like Python does. This lets it run Windows files on Mac, for example.

## Version 3.0 — 2009-06-13

- Fixed the way the Python library was ignored. Too much code was being excluded the old way.

- Tabs are now properly converted in HTML reports. Previously indentation was lost. Fixed issue 6.

- Nested modules now get a proper flat_rootname. Thanks, Christian Heimes.

## Version 3.0b3 — 2009-05-16

- Added parameters to coverage.__init__ for options that had been set on the coverage object itself.

- Added clear_exclude() and get_exclude_list() methods for programmatic manipulation of the exclude regexes.

- Added coverage.load() to read previously-saved data from the data file.

- Improved the finding of code files. For example, .pyc files that have been installed after compiling are now located correctly. Thanks, Detlev Offenbach.

- When using the object API (that is, constructing a coverage() object), data is no longer saved automatically on process exit. You can re-enable it with the auto_data=True parameter on the coverage() constructor. The module-level interface still uses automatic saving.

## Version 3.0b — 2009-04-30

HTML reporting, and continued refactoring.

- HTML reports and annotation of source files: use the new -b (browser) switch. Thanks to George Song for code, inspiration and guidance.

- Code in the Python standard library is not measured by default. If you need to measure standard library code, use the -L command-line switch during execution, or the cover_pylib=True argument to the coverage() constructor.

- Source annotation into a directory (-a -d) behaves differently. The annotated files are named with their hierarchy flattened so that same-named files from different directories no longer collide. Also, only files in the current tree are included.

- coverage.annotate_file is no longer available.

- Programs executed with -x now behave more as they should, for example, __file__ has the correct value.

- .coverage data files have a new pickle-based format designed for better extensibility.

- Removed the undocumented cache_file argument to coverage.usecache().

## Version 3.0b1 — 2009-03-07

Major overhaul.

- Coverage.py is now a package rather than a module. Functionality has been split into classes.

- The trace function is implemented in C for speed. Coverage.py runs are now much faster. Thanks to David Christian for productive micro-sprints and other encouragement.

- Executable lines are identified by reading the line number tables in the compiled code, removing a great deal of complicated analysis code.

- Precisely which lines are considered executable has changed in some cases. Therefore, your coverage stats may also change slightly.

- The singleton coverage object is only created if the module-level functions are used. This maintains the old interface while allowing better programmatic use of coverage.py.

- The minimum supported Python version is 2.3.

## Version 2.85 — 2008-09-14

- Add support for finding source files in eggs. Don’t check for morf’s being instances of ModuleType, instead use duck typing so that pseudo-modules can participate. Thanks, Imri Goldberg.

- Use os.realpath as part of the fixing of file names so that symlinks won’t confuse things. Thanks, Patrick Mezard.

## Version 2.80 — 2008-05-25

- Open files in rU mode to avoid line ending craziness. Thanks, Edward Loper.

## Version 2.78 — 2007-09-30

- Don’t try to predict whether a file is Python source based on the extension. Extension-less files are often Pythons scripts. Instead, simply parse the file and catch the syntax errors. Hat tip to Ben Finney.

## Version 2.77 — 2007-07-29

- Better packaging.

## Version 2.76 — 2007-07-23

- Now Python 2.5 is really fully supported: the body of the new with statement is counted as executable.

## Version 2.75 — 2007-07-22

- Python 2.5 now fully supported. The method of dealing with multi-line statements is now less sensitive to the exact line that Python reports during execution. Pass statements are handled specially so that their disappearance during execution won’t throw off the measurement.

## Version 2.7 — 2007-07-21

- “#pragma: nocover” is excluded by default.

- Properly ignore docstrings and other constant expressions that appear in the middle of a function, a problem reported by Tim Leslie.

- coverage.erase() shouldn’t clobber the exclude regex. Change how parallel mode is invoked, and fix erase() so that it erases the cache when called programmatically.

- In reports, ignore code executed from strings, since we can’t do anything useful with it anyway.

- Better file handling on Linux, thanks Guillaume Chazarain.

- Better shell support on Windows, thanks Noel O’Boyle.

- Python 2.2 support maintained, thanks Catherine Proulx.

- Minor changes to avoid lint warnings.

## Version 2.6 — 2006-08-23

- Applied Joseph Tate’s patch for function decorators.

- Applied Sigve Tjora and Mark van der Wal’s fixes for argument handling.

- Applied Geoff Bache’s parallel mode patch.

- Refactorings to improve testability. Fixes to command-line logic for parallel mode and collect.

## Version 2.5 — 2005-12-04

- Call threading.settrace so that all threads are measured. Thanks Martin Fuzzey.

- Add a file argument to report so that reports can be captured to a different destination.

- Coverage.py can now measure itself.

- Adapted Greg Rogers’ patch for using relative file names, and sorting and omitting files to report on.

## Version 2.2 — 2004-12-31

- Allow for keyword arguments in the module global functions. Thanks, Allen.

## Version 2.1 — 2004-12-14

- Return ‘analysis’ to its original behavior and add ‘analysis2’. Add a global for ‘annotate’, and factor it, adding ‘annotate_file’.

## Version 2.0 — 2004-12-12

Significant code changes.

- Finding executable statements has been rewritten so that docstrings and other quirks of Python execution aren’t mistakenly identified as missing lines.

- Lines can be excluded from consideration, even entire suites of lines.

- The file system cache of covered lines can be disabled programmatically.

- Modernized the code.

## Earlier History

2001-12-04 GDR Created.

2001-12-06 GDR Added command-line interface and source code annotation.

2001-12-09 GDR Moved design and interface to separate documents.

2001-12-10 GDR Open cache file as binary on Windows. Allow simultaneous -e and -x, or -a and -r.

2001-12-12 GDR Added command-line help. Cache analysis so that it only needs to be done once when you specify -a and -r.

2001-12-13 GDR Improved speed while recording. Portable between Python 1.5.2 and 2.1.1.

2002-01-03 GDR Module-level functions work correctly.

2002-01-07 GDR Update sys.path when running a file with the -x option, so that it matches the value the program would get if it were run on its own.